// BkDoc.h : interface of the CBkDoc class
//________________________________________
class CBkDoc : public CDocument
{
protected: // create from serialization only
	CBkDoc();
	DECLARE_DYNCREATE(CBkDoc)

// Attributes
public:
	//______________________________________
	class CBkApp* m_pApp;		//Pointeur sur l'application
	class CBkView* m_pView;	//Pointeur sur la vue
	class CWnd* m_pWnd;			//Pointeur sur la fentre

	//Paramtres____________________________
	CStringArray m_sFrTab;	//Position des franges
	short
	m_iType;			//Voir constructeur BkDoc
	float
	m_fIp,				//I'
	m_fIpp,				//I"
	m_fF1,				//f1, flche initiale (mm)
	m_fDf,				//df, flche supplmentaire exerce au point de pousse (mm)
	m_fa,					//position pt appui flche (mm)
	m_fl,					//long. totale de la poutre (mm)
	m_flv,				//long  visualiser (mm)
	m_fLambda,		//long. d'onde (mm)
	m_fHauteur,
	m_fEchz,
	m_fEchxy,
	m_fDecFr;			//dcalage franges
	short m_radioTypeFrange;
	//Franges digitalises au bouton droit___________
	typedef struct
	{
		short x[50],y[50],d[50];				//Positions
	}
	frange;
	frange f;
	float m_fECH;												//1 pixel = 1 mm
	float m_fFx;
	//Image associe
	CString m_sNomFichierImage;
	//Origine franges dans image
	short m_ixOriFr,m_iyOriFr;
	//______________________________________

	CString m_sNomFic;
	//Attribution type fentre______________
	short m_iNo;
	short m_iL,m_iH,m_iNbB;			
	short m_iX,m_iY,m_iDx,m_iDy;
	float m_fX,m_fY,m_fDx,m_fDy;
	long m_iW,m_iDw;
	//Description de l'image________________
	typedef struct
	{
		unsigned char *ibuff;						//Image buffer address
		unsigned stx, sty, endx, endy;	//Image area to be processed (pixel coords)
		unsigned buffwidth;							//Image buffer width in bytes
		RGBQUAD far *palette;						//Address of palette associated with the image
		int colors;											//Palette colors
		int imgtype;										//Image type: bit 0 = 1 if image is grayscale
		BITMAPINFOHEADER far *bmh;			//BITMAPINFOHEADER header and DIB address
		HBITMAP hBitmap;								//Device-independent bitmap handle
	}
	imgdes;
	imgdes *image;											//Image courante
	class CBkDoc *m_pDocImage;
	//Description du profil__________________________
	typedef struct
	{
		short x1,y1,x2,y2; //Curseur lastique
		BOOL H,V;
		short RGB;
	}
	profil;
	profil p;
	//Description de la cotation_____________________
	typedef struct
	{
		short no;
		short x1[8],y1[8],x2[8],y2[8];	//Vecteurs de cotation
		CString s[8];										//Lgendes
	}
	cotation;
	cotation c;
	//Description des annotations____________________
	typedef struct
	{
		BOOL OK;
		float x[6],y[6];								//Positions
		CString a[6],s[6];							//Lgendes
	}
	annotation;
	annotation a;

	//Variables pour le trac graphique_______________
 	float 
 		m_fLarg,m_fHaut,
 		m_fXmi,m_fXma,m_fYmi,m_fYma,
 		m_fEchx,m_fEchy,
 		m_fXori,m_fYori,  
 		m_fFactx,m_fFacty;

	//Tableau de valeurs______________________________
	short m_iNb,m_iNbMax;
	float (*m_fT)[2];
	//Graphes________________________________________
	short m_iNoGr,m_iNoCourbe;
	class CGraphe *m_pGr;
	//Segment de calibration
	short m_iXC,m_iYC,m_iDxC,m_iDyC;
	//_______________________________________________
	void DimensionnerFenetre(short l,short h);
	void InitAnnotations(void);

	float RechercheMaxi1(void);
	float RechercheMaxi(void);
	long Luminance1(float x,float maxi);
	long Luminance(float x,float maxi);

	void Interferences1(void);
	void Interferences2(void);
	void MAJ_Para_Doc_App(void);
	void MAJ_Para_App_Doc(void);
	float _2appuis(float x,float f,float l,float a);
	float _encastree(float x,float f,float a);
	//_______________________________________________

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CBkDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CBkDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CBkDoc)
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
