// BkView.cpp : implementation of the CBkView class
#include "stdafx.h"
#include "Bk.h"
#include "BkDoc.h"
#include "BkView.h"
#include "ProfilDlg.h"
#include "CoteDlg.h"
#include "AnnotDlg.h"
#include "Vicdefs.h"
#include "GeoAna.h"
#include "Dessin.h"
#include "Graphe.h"
#include "CalbDlg.h"
#include "ParaDlg.h"

#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//________________________________________
// CBkView
IMPLEMENT_DYNCREATE(CBkView, CView)

BEGIN_MESSAGE_MAP(CBkView, CView)
	//{{AFX_MSG_MAP(CBkView)
	ON_UPDATE_COMMAND_UI(ID_FILE_OPEN, OnUpdateFileOpen)
	ON_WM_CONTEXTMENU()
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONDOWN()
	ON_COMMAND(ID_FILE_SAVE, OnFileSave)
	ON_COMMAND(ID_FILE_SAVE_AS, OnFileSaveAs)
	ON_WM_KEYDOWN()
	ON_WM_SETFOCUS()
	ON_UPDATE_COMMAND_UI(ID_FILE_SAVE, OnUpdateFileSave)
	ON_UPDATE_COMMAND_UI(ID_FILE_SAVE_AS, OnUpdateFileSaveAs)
	ON_WM_KILLFOCUS()
	ON_COMMAND(ID__CUR_SOURIS, InitSouris)
	ON_COMMAND(ID__POS_FRANGE, PositionFrange)
	ON_COMMAND(ID__OR_FRANGE, OrigineFrange)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()
//________________________________________
// CBkView construction/destruction
CBkView::CBkView()
{
	m_pApp=(CBkApp*)AfxGetApp();
	InitZoom();
}
//________________________________________
CBkView::~CBkView()
{
}
//________________________________________
BOOL CBkView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs
	return CView::PreCreateWindow(cs);
}
//________________________________________
void CBkView::PIX_FEN(short xp,short yp,float *xmm,float *ymm) 
{
	//Changement de coordonnes Souris(pixels) -> Fentre
	class CBkDoc *pDoc=GetDocument();
	float 
		x,y,
		f_ech,f_echx,f_echy;
	CRect rect;
	GetClientRect(rect);
	f_echx=rect.right/(pDoc->m_fXma-pDoc->m_fXmi);
	f_echy=rect.bottom/(pDoc->m_fYma-pDoc->m_fYmi);
	//Calcul des coordonnes souris dans le repre du graphe
	if (f_echx<f_echy) 
		f_ech=f_echx; 
	else
		f_ech=f_echy;
	*xmm=pDoc->m_fXmi+xp/f_ech;
	*ymm=pDoc->m_fYma-yp/f_ech;
}
//________________________________________
void CBkView::FEN_GR(float xmm,float ymm,float *x,float *y) 
{
 	//Changement de coordonnes Fentre -> Graphe
	class CBkDoc *pDoc=GetDocument();
	*x=(xmm/pDoc->m_fEchx+pDoc->m_fXori)*pDoc->m_fFactx;
	*y=(ymm/pDoc->m_fEchy+pDoc->m_fYori)*pDoc->m_fFacty;
}
//________________________________________
void CBkView::GR_TAB(float x,float y,float *xt,float *yt) 
{
 	//Changement de coordonnes Graphe -> Tableau de mesures
	class CBkDoc *pDoc=GetDocument();
	*xt=x/pDoc->m_fFactx;
	*yt=y/pDoc->m_fFacty;
}
//________________________________________
void CBkView::TAB_GR(float xt,float yt,float *x,float *y) 
{
 	//Changement de coordonnes Tableau de mesures -> Graphe
	class CBkDoc *pDoc=GetDocument();
	*x=xt*pDoc->m_fFactx;
	*y=yt*pDoc->m_fFacty;
}
//________________________________________
void CBkView::GR_FEN(float x,float y,float *xmm,float *ymm) 
{
 	//Changement de coordonnes Graphe -> Fentre 
	class CBkDoc *pDoc=GetDocument();
	*xmm=(x/pDoc->m_fFactx-pDoc->m_fXori)*pDoc->m_fEchx;
	*ymm=(y/pDoc->m_fFacty-pDoc->m_fYori)*pDoc->m_fEchy;
}
//________________________________________
void CBkView::FEN_PIX(float xmm,float ymm,short *xp,short *yp) 
{
	//Changement de coordonnes Fentre -> Pixel (ex: Souris)
	class CBkDoc *pDoc=GetDocument();
	float 
		x,y,
		f_ech,f_echx,f_echy;
	CRect rect;

	GetClientRect(rect);
	f_echx=rect.right/(pDoc->m_fXma-pDoc->m_fXmi);
	f_echy=rect.bottom/(pDoc->m_fYma-pDoc->m_fYmi);
	//Calcul des coordonnes souris dans le repre du graphe
	if (f_echx<f_echy) 
		f_ech=f_echx; 
	else
		f_ech=f_echy;
	*xp=(xmm-pDoc->m_fXmi)*f_ech;
	*yp=(-ymm+pDoc->m_fYma)*f_ech;
}
//________________________________________
void CBkView::OnSetFocus(CWnd* pOldWnd) 
{
	CView::OnSetFocus(pOldWnd);
	CBkDoc* pDoc=GetDocument();
	m_pApp->m_iNo=pDoc->m_iNo;
	
	if (m_pApp->m_pParaDlg!=NULL)
	{
		//Ouverture d'une bote Paramtres au dmarrage du programme
		m_pApp->m_pParaDlg->MAJ(pDoc);
	}
	
}
//________________________________________
void CBkView::OnKillFocus(CWnd* pNewWnd) 
{
	CView::OnKillFocus(pNewWnd);
	CBkDoc* pDoc=GetDocument();

	pDoc->MAJ_Para_Doc_App();

}
//________________________________________
// CBkView drawing
void CBkView::OnDraw(CDC* pDC)
{
	CBkDoc* pDoc=GetDocument();

	if (m_pApp->m_OKN)
	{
		//Ouverture bote Paramtres  l'ouverture du logiciel
		m_pApp->m_OKN=FALSE;
		m_pApp->m_pParaDlg=new CParaDlg(this);
	}
	if ((pDoc->m_iType&1)==1)
	{
	 //Image
	 OnDrawIm(pDC);
	}
	else
	{
		//CString z;
		//z.Format("%d",pDoc->m_iType);
		//AfxMessageBox(z);
		//Dessin
		if ((pDoc->m_iType&2)==0)
		{
			//Graphe des interfrences
			OnDrawGr(pDC);
		}
		else
		{
			//Poutre
			if ((pDoc->m_iType&4)==0)
			{
				//Poutre dans le plan XY
				OnDrawXY(pDC);
			}
			else
			{
				//Dforme dans le plan XZ
				OnDrawXZ(pDC);
			}						
		}
	}
	
}
//________________________________________
void CBkView::OnDrawIm(CDC* pDC)
{
	CBkDoc* pDoc=GetDocument();

	//CString z;z.Format("%d",pDoc->m_iType);AfxMessageBox(z);

	pDoc->m_sNomFichierImage=pDoc->m_sNomFic;
	short i,j;
	float PI=4*atan(1),a,b,x,y;
	long w;

	HDC hDC;
	hDC=pDC->m_hDC;
	HPALETTE hpal;
	CSize size; 
	CPoint pt;
	CPen 
		*plumeB=NULL,
		*plumeR=NULL,
		*plumeJ=NULL,
		*pOldPen=NULL;
	CFont 
		*fntA=NULL,
		*fntB=NULL,  
		*pOldFont=NULL;
	COLORREF clrOld;	
	CRect rect;
	GetClientRect(rect);
	class CGeoAna *pGeo;
	pGeo=new CGeoAna();  
	int ech;
	if (pDC->IsPrinting())
	{
		pDC->SetMapMode(MM_ISOTROPIC) ;
		ech=3;
		pDC->DPtoLP(rect);            
		rect.BottomRight().x=rect.BottomRight().x*ech;
		rect.BottomRight().y=rect.BottomRight().y*ech;
		pDC->SetWindowExt(pDoc->m_iL,pDoc->m_iH);
		pDC->SetViewportExt(pDoc->m_iL*ech,pDoc->m_iH*ech);
	}
	else
	{
		pDC->DPtoLP(rect);            
	}
	fntA=new CFont();
	fntB=new CFont();
	//Plume bleue
	plumeB=new CPen(PS_SOLID,1,RGB(0,0,255));
 	//Plume rouge
	plumeR=new CPen(PS_SOLID,1,RGB(255,0,0));
	//Plume jaune
	plumeJ=new CPen(PS_SOLID,1,RGB(255,255,0));
	pDC->SetBkMode(TRANSPARENT);

	if (fntA!=NULL && fntB!=NULL && plumeB!=NULL && plumeR!=NULL && plumeJ!=NULL)
	{
		if (fntA->CreateFont(14,0,0,0,FW_MEDIUM,FALSE,FALSE,FALSE,ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH,"Arial"))
		{
			pOldFont=pDC->SelectObject(fntA);
			pOldPen=pDC->SelectObject(plumeJ);        
			if (pOldFont!=NULL && pOldPen!=NULL)
			{
				pDC->SetTextAlign(TA_BASELINE);
				clrOld=pDC->SetTextColor(RGB(0,0,255));
				//Visualisation image_____________
				viewimage(m_hWnd,hDC,&hpal,0,0,pDoc->image);
				short X1,Y1,X2,Y2;
				//Trac de profils________________
				if (pDoc->p.x1>0 && pDoc->p.y1>0)
				{
					pDC->SelectObject(plumeJ);
					pDC->MoveTo(pDoc->p.x1,pDoc->p.y1);
					pDC->LineTo(pDoc->p.x2,pDoc->p.y2);
					MarqueDePointage(pDC,pDoc->p.x1,pDoc->p.y1,RGB(0,0,255));
					MarqueDePointage(pDC,pDoc->p.x2,pDoc->p.y2,RGB(0,0,255));
					if (pDoc->p.x1<pDoc->p.x2)
					{
						X1=pDoc->p.x1;X2=pDoc->p.x2;
					}
					else
					{
						X2=pDoc->p.x1;X1=pDoc->p.x2;
					}
					if (pDoc->p.y1<pDoc->p.y2)
					{
						Y1=pDoc->p.y1;Y2=pDoc->p.y2;
					}
					else
					{
						Y2=pDoc->p.y1;Y1=pDoc->p.y2;
					}
					//Coordonnes du curseur (Dx,Dy,X,Y)
					if (pDoc->p.H)
					{
						//PROFIL HORIZONTAL 
						pDC->SelectObject(plumeR);
						pDC->MoveTo(X1,pDoc->m_iH-0);
						pDC->LineTo(X1,pDoc->m_iH-255);
						pDC->LineTo(X2,pDoc->m_iH-255);
						pDC->LineTo(X2,pDoc->m_iH-0);
						pDC->MoveTo(X1,pDoc->m_iH);
						for (i=X1;i<=X2;i++)
						{
							pGeo->d2p(X1,Y1,X2,Y2,&a,&b);
							pGeo->p2d(X1,Y1,a,i,0,PI/2,&x,&y);
							if (x!=1e10 && y!=1e10)
							{
								w=getpixelcolor(pDoc->image,(short)(x),(short)(y));
								if (pDoc->p.RGB==0) w=w&255;
								if (pDoc->p.RGB==1) w=(w>>8)&255;
								if (pDoc->p.RGB==2) w=(w>>16)&255;
								pDC->LineTo(i,pDoc->m_iH-w);
							}
						}
					}
					if (pDoc->p.V)
					{
						//PROFIL VERTICAL 
						pDC->SelectObject(plumeB);
						pDC->MoveTo(0,Y1);
						pDC->LineTo(255,Y1);
						pDC->LineTo(255,Y2);
						pDC->LineTo(0,Y2);
						pDC->MoveTo(0,Y1);
						for(j=Y1;j<=Y2;j++)
						{
							pGeo->d2p(X1,Y1,X2,Y2,&a,&b);
							pGeo->p2d(X1,Y1,a,0,j,0,&x,&y);
							if (x!=1e10 && y!=1e10)
							{
								w=getpixelcolor(pDoc->image,(short)(x),(short)(y));
								if (pDoc->p.RGB==0) w=w&255;
								if (pDoc->p.RGB==1) w=(w>>8)&255;
								if (pDoc->p.RGB==2) w=(w>>16)&255;
								pDC->LineTo(w,j);
							}
						}
					}		
				}
				//Marquage position souris________
				if (pDoc->m_iDx>0 && pDoc->m_iDy>0)
				{
					MarqueDePointage(pDC,pDoc->m_iDx,pDoc->m_iDy,RGB(255,255,0));
					pDC->SetTextColor(RGB(255,255,0));
					pDC->TextOut(pDoc->m_iDx+6,pDoc->m_iDy+3,"(0,0)");
				}


					//50 mm
					pDC->SelectObject(plumeB);
					pDC->MoveTo(20,pDoc->m_iH-25);
					pDC->LineTo(20,pDoc->m_iH-20);
					if ((pDoc->m_iType&32)==32)
					{
						pDC->LineTo(20+50*pDoc->m_fECH,pDoc->m_iH-20);
						pDC->LineTo(20+50*pDoc->m_fECH,pDoc->m_iH-25);
					}
					else
					{
						pDC->LineTo(20+50,pDoc->m_iH-20);
						pDC->LineTo(20+50,pDoc->m_iH-25);
					}
					pDC->SetTextColor(RGB(0,0,255));
					if ((pDoc->m_iType&32)==32)
						pDC->TextOut(28+50*pDoc->m_fECH,pDoc->m_iH-20,"50 mm");
					else
						pDC->TextOut(28+50*pDoc->m_fEchx,pDoc->m_iH-20,"50 pixels");

				//Franges_________________________
				CString s1,s2;
				s1=pDoc->m_sNomFic;
				s1.MakeUpper();
				s2=pDoc->m_sNomFichierImage;
				s2.MakeUpper();
				//if (s1.Find(s2)!=-1 && m_pApp->m_pDocImage==pDoc)
				{
					//La position des franges n'est dessine que dans l'image associe
					for (i=0;i<50;i++)
					{
						if (pDoc->f.x[i]!=-1)
						{
							MarqueDePointage(pDC,pDoc->f.x[i],pDoc->f.y[i],RGB(0,255,255));
							pDC->SetTextColor(RGB(0,255,255));
							CString z;
							float r,r1,l;
							//r=1.0*(x2-x1);
							r=1.0*(pDoc->f.x[i]-pDoc->m_ixOriFr)/pDoc->m_fECH;
							//r1=1.0*(y2-y1);
							r1=(pDoc->f.y[i]-pDoc->m_iyOriFr)/pDoc->m_fECH;
							
							l=pow(pow(r,2)+pow(r1,2),0.5);


							z.Format("%1.0f",l);
							pDC->TextOut(pDoc->f.x[i]+6,pDoc->f.y[i]+3,z);
						}
					}
					//Point origines des franges (encastrement, appui, ....)
					if (pDoc->m_ixOriFr!=-1)
					{
						MarqueDePointage(pDC,pDoc->m_ixOriFr,pDoc->m_iyOriFr,RGB(255,0,0));
						pDC->SetTextColor(RGB(255,0,0));
						pDC->TextOut(pDoc->m_ixOriFr+6,pDoc->m_iyOriFr+3,"Origine franges");
					}
				}
				//Calibration_____________________
				if (m_pApp->m_pCalbDlg!=NULL)
				{
					pDC->SelectObject(plumeJ);
					if (pDoc->m_iXC!=-1 && pDoc->m_iYC!=-1)
					{
						pDC->MoveTo(pDoc->m_iXC,pDoc->m_iYC);
						pDC->LineTo(pDoc->m_iDxC,pDoc->m_iDyC);
						MarqueDePointage(pDC,pDoc->m_iXC,pDoc->m_iYC,RGB(0,0,255));
						MarqueDePointage(pDC,pDoc->m_iDxC,pDoc->m_iDyC,RGB(0,0,255));
					}
				}
				//Cotation________________________
				for (i=0;i<8;i++)
				{
					if (pDoc->c.s[i].GetLength()>0)
					{
						pDC->SelectObject(plumeB);
						pDC->MoveTo(pDoc->c.x1[i],pDoc->c.y1[i]);
						pDC->LineTo(pDoc->c.x2[i],pDoc->c.y2[i]);
						MarqueDePointage(pDC,pDoc->c.x1[i],pDoc->c.y1[i],RGB(0,0,255));
						MarqueDePointage(pDC,pDoc->c.x2[i],pDoc->c.y2[i],RGB(0,0,255));
						pGeo->d2p(pDoc->c.x1[i],pDoc->c.y1[i],pDoc->c.x2[i],pDoc->c.y2[i],&a,&b);
						//Fonte incline de l'angle de la cote
						if (fntB->CreateFont(14,0,(short)(-1800*a/3.14),0,FW_MEDIUM,FALSE,FALSE,FALSE,ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH,"Arial"))
						{
							pDC->SelectObject(&fntB);
							pDC->SetTextAlign(TA_CENTER|TA_BOTTOM);
							pDC->TextOut((pDoc->c.x2[i]+pDoc->c.x1[i])/2+(short)(sin(a)*3),(pDoc->c.y2[i]+pDoc->c.y1[i])/2-(short)(sin(a)*2),pDoc->c.s[i]);
							fntB->DeleteObject();
						}
					}
				}
				//Annotations_____________________
				if (pDoc->a.OK)
				{
					//Dans l'image
					EcritAnnotations(pDC);
				}
				pDC->SelectObject(pOldFont);
				pDC->SetTextColor(clrOld);
				pDC->SelectObject(pOldPen);
			}//OldFont et OldPen OK
			else
			{
				AfxMessageBox("Faire d'urgence une sauvegarde sous .skl !!");
			}
			fntA->DeleteObject();
		}//fntA OK
		plumeB->DeleteObject(); 
		plumeR->DeleteObject(); 
		plumeJ->DeleteObject(); 
	}//Pointeurs sur fontes et plumes OK
	delete fntA;
	delete fntB;
	delete plumeR;
	delete plumeB;
	delete plumeJ;
	delete pGeo;
}
//Trac d'un graphe dans la fentre_______
void CBkView::OnDrawGr(CDC* pDC)
{
	CBkDoc* pDoc=GetDocument();
	CString s;
	CPen 
		plumeB,
		plumeR,
		plumeJ,
		*pOldPen;
	CFont 
		fntA,  
		*pOldFont;
	COLORREF clrOld;	

	fntA.CreateFont(15,0,0,0,FW_MEDIUM,FALSE,FALSE,FALSE,ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH,"Arial");
	pOldFont=pDC->SelectObject(&fntA);	  
	pDC->SetTextAlign(TA_BASELINE);
	clrOld=pDC->SetTextColor(RGB(0,0,255));
	//Plume bleue
	plumeB.CreatePen(PS_SOLID,1,RGB(0,0,255));
 	//Plume rouge
	plumeR.CreatePen(PS_SOLID,1,RGB(255,0,0));
	//Plume jaune
	plumeJ.CreatePen(PS_SOLID,1,RGB(255,255,0));
	pOldPen=pDC->SelectObject(&plumeB);        

	CRect rect;
	GetClientRect(rect);  
	pDC->DPtoLP(rect);            
  float x,y,ech;
	if (pDC->IsPrinting())
	{
		//Dtermination du systme de coordonnes     
		pDC->SetMapMode(MM_TWIPS) ; 
		//Echelle pour sortie imprimante en fonction MM_TWIPS
		ech=1440.0/25.4;//1 twip = 1/1440e de pouce!
		//Dcalage axes
		pDC->SetWindowOrg(ech*pDoc->m_fXmi,ech*pDoc->m_fYma);
	}
	else
	{
		//1 mm est converti vers 100 pixels graphiques!
		ech=100.0;
		//Dtermination du systme de coordonnes     
		pDC->SetMapMode(MM_ISOTROPIC) ;
		//Dimensions de la fentre 
		pDC->SetWindowExt(ech*(pDoc->m_fXma-pDoc->m_fXmi),-ech*(pDoc->m_fYma-pDoc->m_fYmi));
		//Dcalage axes
		pDC->SetWindowOrg(ech*pDoc->m_fXmi,ech*pDoc->m_fYma);
		pDC->SetViewportExt(rect.right,rect.bottom);
	}
	class CDessin *pDes;
	pDes=new CDessin(pDC,pDoc,ech);
	pDes->Zoom(m_fZoomXmi,m_fZoomYmi,m_fZoomXma,m_fZoomYma);
	short err;
	switch ((pDoc->m_iType&8))
	{
		case 0:
			pDoc->Interferences1();
			err=pDes->Graphe(0,"POUTRE ENCASTREE A UNE EXTREMITE");
		break;
		case 8:
			pDoc->Interferences2();
			err=pDes->Graphe(0,"POUTRE SUR 2 APPUIS");
		break;
	}	
	if (err==0)
	{
		//Trac de la marque de pointage  la position de la souris
		if (pDoc->m_iDx!=0 && pDoc->m_iDy!=0 && m_pApp->m_pAnnotDlg==NULL)
		{                          
			if (m_pGr->OK())
				pDes->MarqueDePointageVal(RGB(0,0,255),pDoc->m_fDx,pDoc->m_fDy);
			else
				pDes->MarqueDePointageVal(RGB(0,0,0),pDoc->m_fDx,pDoc->m_fDy);
		}
		//Annotations_________________________
		if (pDoc->a.OK)
		{
			//Dans le graphe
			pDes->EcritAnnotations();
		}
		m_iZoom=-1;
		//Trac rgression
		//pDes->TraceReg(pDoc->m_iNoGr);
	}
	pDC->SelectObject(pOldPen);
	plumeB.DeleteObject(); 
	plumeR.DeleteObject(); 
	plumeJ.DeleteObject(); 
	pDC->SelectObject(pOldFont);
	fntA.DeleteObject();
	pDC->SetTextColor(clrOld);
	delete pDes;
}
//Trac poutre XY_________________________
void CBkView::OnDrawXY(CDC* pDC)
{
	CBkDoc* pDoc=GetDocument();
	CString s;
	CPen 
		plumeB,
		plumeN,
		plumeR,plumeR1,
		plumeJ,
		*pOldPen;
	CFont 
		fntA,  
		*pOldFont;
	COLORREF clrOld;	

	CRect rect;
	GetClientRect(rect);  
	pDC->DPtoLP(rect);            
  float ech;
	if (pDC->IsPrinting())
	{
		//Dtermination du systme de coordonnes     
		pDC->SetMapMode(MM_TWIPS) ; 
		//Echelle pour sortie imprimante en fonction MM_TWIPS
		ech=1440.0/25.4;//1 twip = 1/1440e de pouce!
		//Dcalage axes
		pDC->SetWindowOrg(ech*pDoc->m_fXmi,ech*pDoc->m_fYma);
	}
	else
	{
		//1 mm est converti vers 100 pixels graphiques!
		ech=100.0;
		//Dtermination du systme de coordonnes     
		pDC->SetMapMode(MM_ISOTROPIC) ;
		//Dimensions de la fentre 
		pDC->SetWindowExt(ech*(pDoc->m_fXma-pDoc->m_fXmi),-ech*(pDoc->m_fYma-pDoc->m_fYmi));
		//Dcalage axes
		pDC->SetWindowOrg(ech*pDoc->m_fXmi,ech*pDoc->m_fYma);
		pDC->SetViewportExt(rect.right,rect.bottom);
	}
	class CDessin *pDes;
	pDes=new CDessin(pDC,pDoc,ech);

	fntA.CreateFont((short)(ech*4.5),0,0,0,FW_MEDIUM,FALSE,FALSE,FALSE,ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH,"Arial");
	pOldFont=pDC->SelectObject(&fntA);	  
	pDC->SetTextAlign(TA_BASELINE);
	clrOld=pDC->SetTextColor(RGB(0,0,255));
	plumeB.CreatePen(PS_SOLID,1,RGB(0,0,255));
	plumeR.CreatePen(PS_DOT,30,RGB(255,0,0));
	plumeR1.CreatePen(PS_SOLID,30,RGB(255,0,0));
	plumeJ.CreatePen(PS_SOLID,1,RGB(255,255,0));
	plumeN.CreatePen(PS_SOLID,(int)(0.5*ech),RGB(0,0,0));
	pOldPen=pDC->SelectObject(&plumeB);        

	float 
		x,d,fEchxy;
	//Echelle suivant x et y
	if (pDoc->m_flv<pDoc->m_fl)
	{
		x=pDoc->m_flv;
	}
	else
	{
		x=pDoc->m_fl;
	}
	fEchxy=(pDoc->m_fXma-20)/x;
	//fEchxy=1;
	pDoc->m_fEchxy=fEchxy;

	pDes->Cadre(pDoc->m_fXmi,pDoc->m_fYmi,pDoc->m_fXma,pDoc->m_fYma);
	pDes->Cadre(pDoc->m_fXmi+3,pDoc->m_fYmi+3,pDoc->m_fXma-3,pDoc->m_fYma-3);

	//Affichage paramtres
	pDC->SelectObject(&plumeB);        
	pDC->SetTextAlign(TA_LEFT);
	if ((pDoc->m_iType&8)==0)	s="Modle: Poutre encastre"; else	s="Modle: Poutre sur 2 appuis";
	pDes->TextOut(pDoc->m_fXmi+6,pDoc->m_fYma-8,s);
	s.Format("Flche(m): %1.1f",pDoc->m_fDf*1000);
	pDes->TextOut(pDoc->m_fXmi+6,pDoc->m_fYma-13,s);
	s.Format("Dcalage(mm): %1.1f",pDoc->m_fDecFr);
	pDes->TextOut(pDoc->m_fXmi+6,pDoc->m_fYma-18,s);
	if (pDoc->m_sNomFichierImage.GetLength()!=0)
	{
		s.Format("(B.K.) Image associe: %s",pDoc->m_sNomFichierImage);
		pDes->TextOut(pDoc->m_fXmi+6,pDoc->m_fYmi+9,s);

	}
	//Trac poutre vue de face  la position (0,0) avec plume C
	pDC->SelectObject(&plumeN);        
	pDes->Line(0,0,x*fEchxy,0);
	pDes->Line(x*fEchxy,0,x*fEchxy,pDoc->m_fHauteur);
	pDes->Line(x*fEchxy,pDoc->m_fHauteur,0,pDoc->m_fHauteur);
	pDes->Line(0,pDoc->m_fHauteur,0,0);
	//Division des axes avec plume B et fonte B centre
	pDC->SelectObject(&plumeB);        
	pDC->SetTextAlign(TA_CENTER);							
	d=0.0;
	do
	{
		if (fabs(floor(d/10)-d/10)<0.01)
		{
			pDes->Line(d*fEchxy,-0.5,d*fEchxy,-3.5);
			s.Format("%3.0f",d);
			pDes->TextOut(d*fEchxy,-5,s);
		}
		else
		{
			pDes->Line(d*fEchxy,-0.5,d*fEchxy,-2.5);
		}
		d=d+2.0;
	}
	while (d<=x); 
	//Calcul de la position du maxi des franges brillantes
	short i,n;
	float x1,maxi;
	long w,w1;
	switch ((pDoc->m_iType)&8)
	{
		case 0://Encastre
			maxi=pDoc->RechercheMaxi();
			for (x=0;x<=pDoc->m_fl;x=x+0.5)
			{
				//On cherche la valeur la plus grande sur 0.5 mm
				w1=0;
				for (x1=x;x1<x+1.0;x1=x1+0.5/50)
				{
		
					w=pDoc->Luminance(x1,maxi);
					if (w>w1) w1=w;
				}
				pDC->SelectObject(&(m_pApp->plume[w1]));
				for (x1=x;x1<x+0.5;x1=x1+0.5/50)
				{
					if (x1<=pDoc->m_fl && x1<=pDoc->m_flv) 
					{
						pDes->Line(x1*fEchxy,0.5,x1*fEchxy,pDoc->m_fHauteur-0.05);
					}
				}
			}
		break;
		case 8://2 appuis
			maxi=pDoc->RechercheMaxi1();
			for (x=0;x<=pDoc->m_fl;x=x+0.5)
			{
				//On cherche la valeur la plus grande sur 0.5 mm
				w1=0;
				for (x1=x;x1<x+1.0;x1=x1+0.5/50)
				{
		
					w=pDoc->Luminance1(x1,maxi);
					if (w>w1) w1=w;
				}
				pDC->SelectObject(&(m_pApp->plume[w1]));
				for (x1=x;x1<x+0.5;x1=x1+0.5/50)
				{
					if (x1<=pDoc->m_fl && x1<=pDoc->m_flv) 
					{
						pDes->Line(x1*fEchxy,0.5,x1*fEchxy,pDoc->m_fHauteur-0.05);
					}
				}
			}
		break;
	}
	
	//Matrialisation du point d'appui de la flche
	pDC->SelectObject(&plumeR1);        
	if (pDoc->m_fa<pDoc->m_flv && pDoc->m_fa<pDoc->m_fl)
	{
		pDes->Circle(pDoc->m_fa*fEchxy,pDoc->m_fHauteur/2,1.2);
		pDC->SelectObject(&plumeB);        
		pDes->MoveTo(pDoc->m_fa*fEchxy,-10);
		pDes->LineTo(pDoc->m_fa*fEchxy,-15);
		s.Format("a(mm) = %1.1f",pDoc->m_fa);
		pDC->SetTextAlign(TA_CENTER);
		pDes->TextOut(pDoc->m_fa*fEchxy,-15,s);
		pDC->SetTextAlign(TA_LEFT);

	}

	//Franges exp. en vue de face d'aprs valeurs du tableau m_sFrTab avec plumeR
	n=pDoc->m_sFrTab.GetSize();
	for (i=0;i<n;i++)
	{
		sscanf(pDoc->m_sFrTab.GetAt(i),"%f",&x);
		//Dcalage des franges
		x=x+pDoc->m_fDecFr;
		if (x<=pDoc->m_fl && x<=pDoc->m_flv) 
		{
			pDC->SelectObject(&plumeR);        
			pDes->Line(x*fEchxy,0,x*fEchxy,pDoc->m_fHauteur);
			//Triangle position frange (09/10/06)
			pDC->SelectObject(&plumeB);        
			pDes->Line(x*fEchxy,pDoc->m_fHauteur+0.8,x*fEchxy-2,pDoc->m_fHauteur+3.5+0.8);
			pDes->Line(x*fEchxy-2,pDoc->m_fHauteur+3.5+0.8,x*fEchxy+2,pDoc->m_fHauteur+3.5+0.8);
			pDes->Line(x*fEchxy+2,pDoc->m_fHauteur+3.5+0.8,x*fEchxy,pDoc->m_fHauteur+0.8);
		}
	}
	//Annotations___________________________
	if (pDoc->a.OK)
	{
		//Dans le graphe
		pDes->EcritAnnotations();
	}
	pDC->SelectObject(pOldPen);
	plumeB.DeleteObject(); 
	plumeR.DeleteObject(); 
	plumeR1.DeleteObject(); 
	plumeJ.DeleteObject(); 
	plumeN.DeleteObject(); 
	pDC->SelectObject(pOldFont);
	fntA.DeleteObject();
	pDC->SetTextColor(clrOld);
	delete pDes;
}
//Trac dforme XZ_______________________
void CBkView::OnDrawXZ(CDC* pDC)
{
	CBkDoc* pDoc=GetDocument();
	CString s;
	CPen 
		plumeA,
		plumeB,
		plumeN,
		plumeG,
		plumeR,
		plumeJ,
		*pOldPen;
	CFont 
		fntA,  
		*pOldFont;
	COLORREF clrOld;	

	CRect rect;
	GetClientRect(rect);  
	pDC->DPtoLP(rect);            
  float 
		f,fEchxy,lambda,x,y,xd=0,yd=0,y2,x1,r,maxi,K,InterFrMaxi,XDER,xFR1,xFR2,xMAXI,
		ech,PI=4*atan(1);
	short i,n;	
	if (pDC->IsPrinting())
	{
		//Dtermination du systme de coordonnes     
		pDC->SetMapMode(MM_TWIPS) ; 
		//Echelle pour sortie imprimante en fonction MM_TWIPS
		ech=1440.0/25.4;//1 twip = 1/1440e de pouce!
		//Dcalage axes
		pDC->SetWindowOrg(ech*pDoc->m_fXmi,ech*pDoc->m_fYma);
	}
	else
	{
		//1 mm est converti vers 100 pixels graphiques!
		ech=100.0;
		//Dtermination du systme de coordonnes     
		pDC->SetMapMode(MM_ISOTROPIC) ;
		//Dimensions de la fentre 
		pDC->SetWindowExt(ech*(pDoc->m_fXma-pDoc->m_fXmi),-ech*(pDoc->m_fYma-pDoc->m_fYmi));
		//Dcalage axes
		pDC->SetWindowOrg(ech*pDoc->m_fXmi,ech*pDoc->m_fYma);
		pDC->SetViewportExt(rect.right,rect.bottom);
	}
	class CDessin *pDes;
	pDes=new CDessin(pDC,pDoc,ech);

	fntA.CreateFont((short)(ech*4.5),0,0,0,FW_MEDIUM,FALSE,FALSE,FALSE,ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH,"Arial");
	pOldFont=pDC->SelectObject(&fntA);	  
	pDC->SetTextAlign(TA_BASELINE);
	clrOld=pDC->SetTextColor(RGB(0,0,255));
	plumeB.CreatePen(PS_SOLID,1,RGB(0,0,255));
	plumeR.CreatePen(PS_SOLID,(int)(0.5*ech),RGB(255,0,0));
	plumeJ.CreatePen(PS_SOLID,1,RGB(255,255,0));
	plumeN.CreatePen(PS_SOLID,(int)(0.5*ech),RGB(0,0,0));
	plumeA.CreatePen(PS_SOLID,(int)(0.5*ech),RGB(0,0,255));
	plumeG.CreatePen(PS_SOLID,(int)(0.3*ech),RGB(0,0,0));
	pOldPen=pDC->SelectObject(&plumeB);        

	pDes->Cadre(pDoc->m_fXmi,pDoc->m_fYmi,pDoc->m_fXma,pDoc->m_fYma);
	pDes->Cadre(pDoc->m_fXmi+3,pDoc->m_fYmi+3,pDoc->m_fXma-3,pDoc->m_fYma-3);

	//Affichage paramtres
	pDC->SelectObject(&plumeB);        
	pDC->SetTextAlign(TA_LEFT);
	if ((pDoc->m_iType&8)==0)	s="Modle: Poutre encastre"; else	s="Modle: Poutre sur 2 appuis";
	pDes->TextOut(pDoc->m_fXmi+6,pDoc->m_fYma-8,s);
	s.Format("Flche(m): %1.1f",pDoc->m_fDf*1000);
	pDes->TextOut(pDoc->m_fXmi+6,pDoc->m_fYma-13,s);
	s.Format("Dcalage(mm): %1.1f",pDoc->m_fDecFr);
	pDes->TextOut(pDoc->m_fXmi+6,pDoc->m_fYma-18,s);

	if (pDoc->m_sNomFichierImage.GetLength()!=0)
	{
		s.Format("(B.K.) Image associe: %s",pDoc->m_sNomFichierImage);
		pDes->TextOut(pDoc->m_fXmi+6,pDoc->m_fYmi+9,s);

	}

	maxi=-1e10;
	if((pDoc->m_iType&8)==8)
	{
		for (x1=0;x1<=pDoc->m_fl;x1=x1+1.0)
		{
			y2=pDoc->_2appuis(x1,pDoc->m_fDf,pDoc->m_fl,pDoc->m_fa);
			if (y2>maxi) maxi=y2;
		}
		s.Format("Dformation maxi poutre(m): %1.2f",maxi*1000);
		pDes->TextOut(pDoc->m_fXmi+6,pDoc->m_fYma-23,s);
	}
	else
	{
		y2=pDoc->_encastree(pDoc->m_fl,pDoc->m_fDf,pDoc->m_fa);
		s.Format("Dformation maxi poutre(m): %1.2f",y2*1000);
		pDes->TextOut(pDoc->m_fXmi+6,pDoc->m_fYma-23,s);
	}

	//Vecteurs unitaires de 10 mm  la position (0,0)
	pDC->SelectObject(&plumeG);        
	pDes->Line(0,0,20,0);
	pDes->Line(0,0,0,20);
	pDC->SelectObject(&plumeN);        
	pDes->Fleche(20,0,0,4.0);
	pDes->Fleche(0,20,PI/2,4.0);
	pDes->TextOut(22.0,2.0,"x");
	pDes->TextOut(-4,20,"z");
	//Echelle suivant x et y
	if (pDoc->m_flv<pDoc->m_fl)
	{
		x=pDoc->m_flv;
	}
	else
	{
		x=pDoc->m_fl;
	}
	fEchxy=(pDoc->m_fXma-20)/x;
	pDoc->m_fEchxy=fEchxy;

	//Matrialisation du point d'appui de la flche
	f=pDoc->m_fDf;
	if (pDoc->m_fa<pDoc->m_flv+0.1 && pDoc->m_fa<pDoc->m_fl+0.1)
	{
		pDC->SelectObject(&plumeN);        
		pDes->Line(pDoc->m_fa*fEchxy,f*pDoc->m_fEchz,pDoc->m_fa*fEchxy,f*pDoc->m_fEchz-20);
		pDes->Fleche(pDoc->m_fa*fEchxy,f*pDoc->m_fEchz,PI/2,5);
		s.Format("a(mm) = %1.1f",pDoc->m_fa);
		pDC->SetTextAlign(TA_CENTER);
		pDes->TextOut(pDoc->m_fa*fEchxy,f*pDoc->m_fEchz-22,s);
		pDC->SetTextAlign(TA_LEFT);
	}
	lambda=pDoc->m_fLambda;
	K=1;
	InterFrMaxi=-1e10;
	switch ((pDoc->m_iType)&8)
	{
		case 0://Encastre
			pDC->SelectObject(&plumeA);        
			//Trac dforme d'aprs Rdm
			if (pDoc->m_flv<pDoc->m_fl)
			{
				//Pt. arrive
				x1=pDoc->m_flv;
			}
			else
			{
				//Pt. arrive
				x1=pDoc->m_fl;
			}
			x=0;
			while (x<=x1)
			{
				x=x+1;
				y=pDoc->_encastree(x,f,pDoc->m_fa);
				if (x!=0&& x<pDoc->m_flv && x<pDoc->m_fl) pDes->Line(xd*fEchxy,yd*pDoc->m_fEchz,x*fEchxy,y*pDoc->m_fEchz);
				xd=x;yd=y;
				x=x+1;
			}
		break;
		case 8://Poutre sur deux appuis
			//Dessin des appuis
			pDC->SelectObject(&plumeG);        
			pDes->MoveTo(0,0);pDes->LineTo(-2,3);pDes->LineTo(2,3);pDes->LineTo(0,0);
			if (pDoc->m_fl<=pDoc->m_flv)
			{
				pDes->MoveTo(pDoc->m_fl*fEchxy,0);pDes->LineTo(pDoc->m_fl*fEchxy-2,3);pDes->LineTo(pDoc->m_fl*fEchxy+2,3);pDes->LineTo(pDoc->m_fl*fEchxy,0);
			}
			//Trac dforme d'aprs Rdm
			pDC->SelectObject(&plumeA);        
			x=0.0;

			//Premire partie -> Flche
			while (x<=pDoc->m_fl)
			{
				y=pDoc->_2appuis(x,f,pDoc->m_fl,pDoc->m_fa);

				if (x!=0 && x<=pDoc->m_flv && x<=pDoc->m_fl) pDes->Line(xd*fEchxy,yd*pDoc->m_fEchz,x*fEchxy,y*pDoc->m_fEchz);
				xd=x;yd=y;
				x=x+1.0;
			}
		break;
	}
	
	pDC->SelectObject(&plumeG);        
	pDes->MoveTo(pDoc->m_fl*fEchxy,0);
	pDes->LineTo(pDoc->m_fl*fEchxy,6);
	s.Format("l(mm) = %1.1f",pDoc->m_fl);
	pDC->SetTextAlign(TA_CENTER);
	pDes->TextOut(pDoc->m_fl*fEchxy,-2,s);
	pDC->SetTextAlign(TA_LEFT);


	//Franges exprimentales
	n=pDoc->m_sFrTab.GetSize();
	if((pDoc->m_iType&8)==8)
	{
		InterFrMaxi=-1e10;
		//Pour une poutre sur deux appuis, on recherche l'interfrange maxi
		for (i=0;i<n;i++)
		{
			sscanf(pDoc->m_sFrTab.GetAt(i),"%f",&x);
			if (i!=0)
			{
				if (fabs(x-XDER)>InterFrMaxi+2)
				{
					InterFrMaxi=fabs(x-XDER);
					xFR1=XDER+pDoc->m_fDecFr;
					xFR2=x+pDoc->m_fDecFr;
				}
			}
			XDER=x;
		}
		//Matrialisation interfrange maxi
		xMAXI=(xFR1+xFR2)/2;
		if (InterFrMaxi!=-1e10)
		{
			s.Format("Interfrange exprimental maxi(mm): %1.0f",InterFrMaxi);
			pDes->TextOut(pDoc->m_fXmi+6,pDoc->m_fYma-28,s);
			pDes->Line(xFR1*fEchxy,0,xFR1*fEchxy,5);
			pDes->Line(xFR2*fEchxy,0,xFR2*fEchxy,5);
			//pDes->Line(xMAXI*fEchxy,0,xMAXI*fEchxy,1);
		}
	}

	pDC->SelectObject(&plumeR);        
	for (i=0;i<n;i++)
	{
		sscanf(pDoc->m_sFrTab.GetAt(i),"%f",&x);
		//Dcalage des franges
		x=x+pDoc->m_fDecFr;

		//Premire frange
		if (i==0)
		{
			xd=0;yd=0;
			//Option frange claire et sombre
			if (pDoc->m_radioTypeFrange==0)
			{
				//Si frange sombre, la premire frange est  lambda/2
				y=lambda/2;
			}
			else
			{
				//Si frange claire, la premire frange est  lambda/4
				y=lambda/4;
			}
		}
		else
		{
			//Toutes les autres franges, on augmente ou diminue de lambda/2
			switch ((pDoc->m_iType)&8)
			{
				case 0://Encastre
					y=y+lambda/2;
				break;
				case 8://Poutre sur deux appuis
					if (x<xMAXI-1)
					{
						y=y+lambda/2;	
					}
					else
					if (x>xMAXI+1 && x<xFR2+1)
					{
						//Position interfrange maxi
						if (pDoc->m_radioTypeFrange==1)
						{
							//Claire
							y=y+lambda/2;	
						}
						else
						{
							//Sombre
							//Ajout lambad/4 jusqu'au milieu
							y=y+lambda/4;	
							pDes->Line(xd*fEchxy,pDoc->m_fEchz*yd,xMAXI*fEchxy,pDoc->m_fEchz*y);
							xd=xMAXI;yd=y;
							//Retrait lambda/4 jusqu' prochaine frange
							y=y-lambda/4;	
							pDes->Line(xd*fEchxy,pDoc->m_fEchz*yd,xFR2*fEchxy,pDoc->m_fEchz*y);
							xd=xFR2;yd=y;
						}
					}
					else
					{
						y=y-lambda/2;	
					}

					/*
					y=y+K*lambda/2;	
					if (y>maxi) 
					{
						//Ca change de signe
						K=-1;
					}
					*/
				break;
			}
		}
		if (x<pDoc->m_fl && x<pDoc->m_flv) 
		{
			//																	pt dpart                 pt arrive frange                                
			pDes->Line(xd*fEchxy,pDoc->m_fEchz*yd,x*fEchxy,pDoc->m_fEchz*y);
		}
		xd=x;yd=y;
	}
	//Annotations___________________________
	if (pDoc->a.OK)
	{
		//Dans le graphe
		pDes->EcritAnnotations();
	}
	pDC->SelectObject(pOldPen);
	plumeA.DeleteObject(); 
	plumeB.DeleteObject(); 
	plumeR.DeleteObject(); 
	plumeJ.DeleteObject(); 
	plumeN.DeleteObject(); 
	plumeG.DeleteObject(); 
	pDC->SelectObject(pOldFont);
	fntA.DeleteObject();
	pDC->SetTextColor(clrOld);
	delete pDes;
}
//________________________________________
// CBkView printing
BOOL CBkView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}
void CBkView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}
void CBkView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}
//________________________________________
// CBkView diagnostics
#ifdef _DEBUG
void CBkView::AssertValid() const
{
	CView::AssertValid();
}
void CBkView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}
//________________________________________
CBkDoc* CBkView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CBkDoc)));
	return (CBkDoc*)m_pDocument;
}
#endif //_DEBUG
//________________________________________
// CBkView message handlers
void CBkView::OnInitialUpdate() 
{
	CView::OnInitialUpdate();
	//Taille de la fentre
	CRect	R,R1;
	class CBkDoc* pDoc=GetDocument();
	GetParent()->GetWindowRect(&R1);
	GetParent()->GetClientRect(&R);
	short dx=(R1.right-R1.left)-(R.right-R.left);
	short dy=(R1.bottom-R1.top)-(R.bottom-R.top);

	R.SetRect(0,0,pDoc->m_iL+dx+5,pDoc->m_iH+dy+5);
	R.OffsetRect(-R.left,-R.top);
	GetParent()->SetWindowPos(NULL,0,0,R.right,R.bottom,SWP_NOACTIVATE|SWP_NOZORDER|SWP_NOMOVE);
	GetParent()->InvalidateRect(NULL,FALSE);
	//Mmoriser le pointeur sur la fentre et sur la vue dans le document
	pDoc->m_pWnd=GetParent();
	pDoc->m_pView=this;
	m_pGr=pDoc->m_pGr;
	
	CString s;
	pDoc->m_sNomFic=pDoc->GetTitle();
	s.Format("(%d) %s",pDoc->m_iNo,pDoc->m_sNomFic);
	pDoc->SetTitle(s);
}
//________________________________________
void CBkView::MarqueDePointage(CDC *pDC, short X,short Y,long coul)
{
	CRgn Region;
	CBrush 
		*m_pOldBrush=NULL,
		*brosseA=NULL,
		*brosseB=NULL;

	brosseA=new CBrush();
	brosseB=new CBrush();
	if (brosseA!=NULL && brosseB!=NULL)
	{
		if (brosseA->CreateSolidBrush(RGB(255,255,255)) && brosseB->CreateSolidBrush(coul))
		{
			m_pOldBrush=pDC->SelectObject(brosseA);
			if (m_pOldBrush!=NULL)
			{
				Region.CreateRectRgn(X-3,Y-3,X+3,Y+3);
				pDC->PaintRgn(&Region);
				Region.DeleteObject();
				pDC->SelectObject(brosseB);
				Region.CreateRectRgn(X-2,Y-2,X+2,Y+2);
				pDC->PaintRgn(&Region);
				Region.DeleteObject();
				pDC->SelectObject(m_pOldBrush);
			}
			brosseA->DeleteObject();
			brosseB->DeleteObject();
		}
	}
	delete brosseA;
	delete brosseB;
}
//________________________________________
void CBkView::EcritAnnotations(CDC *pDC)
{
	class CBkDoc *pDoc=GetDocument();
	CFont 
		fnt,
		*m_pOldFont;  
	COLORREF clrOld;	
	CPen
  	plume,
  	*m_pOldPen;
	float x,y;
	short 
		px,py,
		k,l,i,j;
	char s[50];
	CSize taille(0,0);
	
	//Dtermination taille de la zone
	short 
		haut=16,larg=260,	//Hauteur, largeur de la chane,  adapter en fonction taille bote de dialogue
		nbL1=0,						//Nb. de lignes intitul principal
		nbL2=0;						//Nb. de lignes lgende

	fnt.CreateFont(haut-2,0,0,0,FW_MEDIUM,FALSE,FALSE,FALSE,ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH,"Arial");
	m_pOldFont=pDC->SelectObject(&fnt);	  
	clrOld=pDC->SetTextColor(RGB(255,0,255));
  plume.CreatePen(PS_SOLID,0,RGB(255,0,255));
	m_pOldPen=pDC->SelectObject(&plume);

	k=0;
	if (pDoc->a.x[0]!=1e10 && pDoc->a.y[0]!=1e10)
	{
		for(l=0;l<pDoc->a.s[0].GetLength();l++)
		{
			if (pDoc->a.s[0].GetAt(l)=='\r')
			{
				//Passage  la ligne dans bote de dialogue
				k=0;s[k]='\0';
				taille=pDC->GetTextExtent(s);
				nbL1++;
			}
			else
			if (taille.cx>larg-25)
			{
				//On dpasse la largeur de la bote de dialogue, on coupe la chane
				k=0;s[k]='\0';
				taille=pDC->GetTextExtent(s);
				nbL1++;
			}	
			else
			if (pDoc->a.s[0].GetAt(l)!='\n') 
			{
				//On ignore le saut de ligne dans la chane
				s[k]=pDoc->a.s[0].GetAt(l);k++;
				s[k]='\0';taille=pDC->GetTextExtent(s);
			}
		}
		if (k!=0) nbL1++;

		for (k=1;k<6;k++)
		{
			if (pDoc->a.x[k]!=1e10 && pDoc->a.y[k]!=1e10 && pDoc->a.s[k].GetLength()!=0) nbL2++;
		}
	}
	//Rectangle autour de l'intitul principal
	if (nbL1!=0)
	{
		px=(short)pDoc->a.x[0];py=(short)pDoc->a.y[0];
		pDC->Rectangle(px,py,px+larg,py+haut*nbL1);
	}
	//Rectangle autour des lgendes (il faut toujours un intitul pour avoir la position d'criture...)
	if (nbL2!=0 && nbL1!=0) 
	{
		pDC->MoveTo(px+20,py);
		py=py+haut*nbL1-1;
		pDC->Rectangle(px,py,px+larg,py+haut*nbL2);
		pDC->MoveTo(px+30,py);pDC->LineTo(px+30,py+haut*nbL2);
	}
	pDC->SetTextAlign(TA_LEFT|TA_TOP);
	taille.cx=0;
	//Ecriture intitul principal
	if (nbL1!=0)
	{
		px=(short)pDoc->a.x[0];py=(short)pDoc->a.y[0];
		k=0;
		j=py+1;i=px+5;
		for(l=0;l<pDoc->a.s[0].GetLength();l++)
		{
			if (pDoc->a.s[0].GetAt(l)=='\r')
			{
				//Passage  la ligne dans bote de dialogue
				s[k]='\0';
				pDC->TextOut(i,j,s);
				k=0;s[k]='\0';taille=pDC->GetTextExtent(s);
				j=j+haut;
			}
			else
			if (taille.cx>larg-25)
			{
				//La chane dpasse la longueur du cadre
				s[k]=pDoc->a.s[0].GetAt(l);k++;
				s[k]='\0';
				pDC->TextOut(i,j,s);
				k=0;s[k]='\0';taille=pDC->GetTextExtent(s);
				j=j+haut;
			}
			else
			if (pDoc->a.s[0].GetAt(l)!='\n')
			{
				s[k]=pDoc->a.s[0].GetAt(l);
				k++;
				s[k]='\0';
				taille=pDC->GetTextExtent(s);
			}
		}
		if (k!=0)
		{
			s[k]='\0';
			pDC->TextOut(i,j,s);
			j=j+haut;
		}
	}
	//Ecriture lgende
	if (nbL1!=0 && nbL2!=0)
	{
		j=py+haut*nbL1;i=px+5;
		for (k=1;k<6;k++)
		{
			if (pDoc->a.x[k]!=1e10 && pDoc->a.y[k]!=1e10 && pDoc->a.s[k].GetLength()!=0)
			{
				pDC->SetTextAlign(TA_CENTER|TA_TOP);							
				pDC->TextOut(i+10,j,pDoc->a.a[k]);
				pDC->SetTextAlign(TA_LEFT|TA_TOP);							
				pDC->TextOut(i+30,j,pDoc->a.s[k]);
				j=j+haut;
			}
		}	
	}
	//Ecriture repres
	pDC->SetTextAlign(TA_CENTER|TA_BOTTOM);							
	for (k=1;k<6;k++)
	{
		if (pDoc->a.x[k]!=1e10 && pDoc->a.y[k]!=1e10 && pDoc->a.s[k].GetLength()!=0)
		{ 
			//Les coordonnes sont dans le graphique...
			i=(short)pDoc->a.x[k];j=(short)pDoc->a.y[k];
			pDC->TextOut(i,(j-5),pDoc->a.a[k]);
			MarqueDePointage(pDC,i,j,RGB(0,0,255));
		}
	}
	pDC->SelectObject(m_pOldPen);        
	plume.DeleteObject();        
	pDC->SelectObject(m_pOldFont);
	fnt.DeleteObject();                   
	pDC->SetTextColor(clrOld);
}
//________________________________________
void CBkView::MAJ(void) 
{
	class CBkDoc* pDoc=GetDocument();
	CRect r;
	r.left=2;r.right=pDoc->m_iL-2;r.top=2;r.bottom=pDoc->m_iH-2;
	r.NormalizeRect();
	InvalidateRect(r,FALSE);
	pDoc->UpdateAllViews(this,(LPARAM)(LPCRECT)r);
}
//________________________________________
void CBkView::MAJ_G(float xg,float yg) 
{
	CRect rect;
	short
		x,y,
		i=45,j=25;
	float xp,yp;

	GR_FEN(xg,yg,&xp,&yp);
	FEN_PIX(xp,yp,&x,&y);
	rect.left=x-i;rect.right=x+i;rect.top=y-j;rect.bottom=y+j/2;
	InvalidateRect(rect,TRUE);
	GetDocument()->UpdateAllViews(this,(LPARAM)(LPCRECT)rect);
}
//________________________________________
void CBkView::InitZoom(void)
{                       
	m_fZoomXmi=-1e10;
	m_fZoomXma=1e10;
	m_fZoomYmi=-1e10;
	m_fZoomYma=1e10;
	m_iZoom=-1;
}
//________________________________________
void CBkView::PositionFrange(void)
{
	short i,n;
	float x,y;
	CBkDoc* pDoc=GetDocument();

	if (pDoc->m_iType&1==1 && (pDoc->m_iType&32)!=32)
	{
		AfxMessageBox("Image non calibre !");
	}
	if (pDoc->m_ixOriFr>0 && pDoc->m_ixOriFr<pDoc->m_iL && pDoc->m_iyOriFr>0 && pDoc->m_iyOriFr<pDoc->m_iH) 
	if (pDoc->m_iType&1==1)
	{
		n=0;
		for (i=0;i<50;i++)//50 franges maxi
		{
			if (pDoc->f.x[i]!=-1)
			{
				n++;
			}
		}
		if (n>=50-1)
			AfxMessageBox("Nb maxi de franges atteint !");
		//Image_______________________________
		if (m_pApp->m_pParaDlg!=NULL)
		{
			m_pApp->m_pParaDlg->Affecte(pDoc->m_ixOriFr,pDoc->m_iyOriFr,pDoc->m_iX,pDoc->m_iY);
		}
	}
}
//________________________________________
void CBkView::OrigineFrange(void)
{
	short i;
	float x,y;
	CBkDoc* pDoc=GetDocument();
	if (pDoc->m_iType&1==1 && (pDoc->m_iType&32)!=32)
	{
		AfxMessageBox("Image non calibre !");
	}
	if (pDoc->m_iX>0 && pDoc->m_iX<pDoc->m_iL && pDoc->m_iY>0 && pDoc->m_iY<pDoc->m_iH) 
	if (pDoc->m_iType&1==1)
	{
		//Image_______________________________
		if (m_pApp->m_pParaDlg!=NULL)
		{
			//Ecriture clic dans position frange
			pDoc->m_ixOriFr=pDoc->m_iX;
			pDoc->m_iyOriFr=pDoc->m_iY;
			pDoc->UpdateAllViews(NULL);
			//CString z;z.Format("%d,%d",pDoc->m_iX,pDoc->m_iY);AfxMessageBox(z);
		}
	}
}
//________________________________________
void CBkView::InitSouris(void)
{
	//Initialisation curseur souris
	CBkDoc* pDoc=GetDocument();
	pDoc->m_iDx=0;
	pDoc->m_iDy=0;
	pDoc->m_iDw=0;
	pDoc->m_fDx=0.0;
	pDoc->m_fDy=0.0;
	//MAJ uniquement pour une image...
	if ((pDoc->m_iType&1)==1)
	{
		//Profil(s)___________________________
		pDoc->p.x1=0;pDoc->p.x2=0;pDoc->p.y1=0;pDoc->p.y2=0;
		MAJ();	
	}
}
//________________________________________
void CBkView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	float x,y;
	short i,j,k;
	class CBkDoc* pDoc=GetDocument();
	CString s;
	//Appui touche
	if (m_pGr->OK())	
	{
		if (nChar==37)
		{
			//Flche gauche
			for (k=0;k<nRepCnt;k++)
			{
				//Dcrmentation
				m_pGr->Dec();
			}
			x=m_pGr->X();
			y=m_pGr->Y();
			if (x!=1e10 && y!=1e10)
			{
				TAB_GR(x,y,&x,&y);
				MAJ_G(pDoc->m_fDx,pDoc->m_fDy);
	 			pDoc->m_fDx=x;
				pDoc->m_fDy=y;
				MAJ_G(pDoc->m_fDx,pDoc->m_fDy);
				//Si la bote de dialogue d'dition du graphe est ouverte, on transmet le n du pt...
				//if (m_pEditDlg!=NULL) m_pEditDlg->AfficherLigne(m_pGr->N());
			}
		}
		if (nChar==39)
		{
			//Flche gauche
			for (k=0;k<nRepCnt;k++)
			{
				//Incrmentation
				m_pGr->Inc();
			}
			x=m_pGr->X();
			y=m_pGr->Y();
			if (x!=1e10 && y!=1e10)
			{
				TAB_GR(x,y,&x,&y);
				MAJ_G(pDoc->m_fDx,pDoc->m_fDy);
	 			pDoc->m_fDx=x;
				pDoc->m_fDy=y;
				MAJ_G(pDoc->m_fDx,pDoc->m_fDy);
				//Si la bote de dialogue d'dition du graphe est ouverte, on transmet le n du pt...
				//if (m_pEditDlg!=NULL) m_pEditDlg->AfficherLigne(m_pGr->N());
			}
		}
	}
	CView::OnKeyDown(nChar, nRepCnt, nFlags);
}
//________________________________________
void CBkView::OnActivateView(BOOL bActivate, CView* pActivateView, CView* pDeactiveView) 
{
	if (bActivate) 
	{
		m_pApp->m_iNo=GetDocument()->m_iNo;
		//Botes non modales
		if (m_pApp->m_pProfilDlg!=NULL) m_pApp->m_pProfilDlg->MAJ();
	}
	CView::OnActivateView(bActivate, pActivateView, pDeactiveView);
}
//________________________________________
void CBkView::OnContextMenu(CWnd* pWnd, CPoint point) 
{
	class CBkDoc* pDoc=GetDocument();
	CMenu menu;
	BOOL ok=menu.LoadMenu(IDR_POPUP);
	CMenu* pPopup=menu.GetSubMenu(0);
	//Invalidation
	if ((!(pDoc->m_iType&1)) || m_pApp->m_pParaDlg==NULL) menu.EnableMenuItem(ID__POS_FRANGE,MF_GRAYED);

	short	i,n=0;
	for (i=0;i<50;i++)//50 franges maxi
	{
		if (pDoc->f.x[i]!=-1)
		{
			n++;
		}
	}
	if (n>=50) menu.EnableMenuItem(ID__POS_FRANGE,MF_GRAYED);
	if ((!(pDoc->m_iType&1)) || m_pApp->m_pParaDlg==NULL) menu.EnableMenuItem(ID__OR_FRANGE,MF_GRAYED);

	if (pPopup!=NULL) pPopup->TrackPopupMenu(TPM_LEFTALIGN|TPM_RIGHTBUTTON,point.x,point.y,this,NULL);
}
//________________________________________
void CBkView::OnMouseMove(UINT nFlags, CPoint point) 
{
	CBkDoc* pDoc=GetDocument();
	pDoc->m_iW=getpixelcolor(pDoc->image,point.x,point.y);
	pDoc->m_iX=(short)point.x;
	pDoc->m_iY=(short)point.y;

	float x,y;
	PIX_FEN(point.x,point.y,&x,&y);
	FEN_GR(x,y,&x,&y);
	pDoc->m_fX=x;
	pDoc->m_fY=y;

	if (point.x>0 && point.x<pDoc->m_iL && point.y>0 && point.y<pDoc->m_iH) 
	if (nFlags==MK_LBUTTON)
	{
		//Appui bouton gauche pendant dplacement -> Trac d'un segment
		if (m_pApp->m_pCalbDlg!=NULL)
		{
			//Calibration
			pDoc->m_iXC=pDoc->m_iX;
			pDoc->m_iYC=pDoc->m_iY;
			pDoc->m_iDxC=pDoc->m_iDx;
			pDoc->m_iDyC=pDoc->m_iDy;
			m_pApp->m_pCalbDlg->Affecte(pDoc->m_iDx,pDoc->m_iDy,pDoc->m_iX,pDoc->m_iY);
		}
		else
		if (m_pApp->m_pProfilDlg!=NULL)
		{
			//Profil
			pDoc->p.x1=pDoc->m_iDx;
			pDoc->p.x2=pDoc->m_iX;
			pDoc->p.y1=pDoc->m_iDy;
			pDoc->p.y2=pDoc->m_iY;
			m_pApp->m_pProfilDlg->Affecte(pDoc->p.x1,pDoc->p.y1,pDoc->p.x2,pDoc->p.y2);
		}
		else
		if (m_pApp->m_pCoteDlg!=NULL)
		{
			//Cotation
			m_pApp->m_pCoteDlg->Affecte(pDoc->m_iDx,pDoc->m_iDy,pDoc->m_iX,pDoc->m_iY);
		}
		MAJ();//Toute l'image...
	}
	CView::OnMouseMove(nFlags, point);
}
//________________________________________
void CBkView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	CBkDoc* pDoc=GetDocument();
	m_pApp->m_iNo=pDoc->m_iNo;
	float r,x,y,x1,y1;
	pDoc->m_iDx=(short)point.x;
	pDoc->m_iDy=(short)point.y;
	PIX_FEN(point.x,point.y,&x1,&y1);
	FEN_GR(x1,y1,&x,&y);
	if (pDoc->m_iDx>0 && pDoc->m_iDx<pDoc->m_iL && pDoc->m_iDy>0 && pDoc->m_iDy<pDoc->m_iH) 
	if (pDoc->m_iType&1==1)
	{
		//Image_______________________________
		if (m_pApp->m_pAnnotDlg!=NULL)
		{
			//Annotation
			m_pApp->m_pAnnotDlg->Affecte(pDoc->m_iDx,pDoc->m_iDy);
		}
		else
		{
			pDoc->UpdateAllViews(NULL);
		}
	}
	else
	//Dessin
	if ((pDoc->m_iType&0)==0)
	{
		//Graphe interfrences________________
		//Ancienne position m_fDx, m_fDy
		MAJ_G(pDoc->m_fDx,pDoc->m_fDy);
		pDoc->m_iDx=(short)point.x;
		pDoc->m_iDy=(short)point.y;
		if (m_pApp->m_pAnnotDlg!=NULL)
		{
			//Annotation
			m_pApp->m_pAnnotDlg->Affecte1(x,y);
		}
		else
		if (m_pGr->AccrocheGraphe(x,y,0.02))
		{
			//x=pDoc->m_fT[m_pGr->N()][m_pGr->C1()];
			//y=pDoc->m_fT[m_pGr->N()][m_pGr->C2()];
			x=m_pGr->X();
			y=m_pGr->Y();
			TAB_GR(x,y,&x,&y);
			//Si la bote de dialogue d'dition du graphe est ouverte, on transmet le n du pt...
			//if (m_pEditDlg!=NULL) m_pEditDlg->AfficherLigne(m_pGr->N());
		}
		//Nouvelle position m_fDx,m_fDy
		pDoc->m_fDx=x;
		pDoc->m_fDy=y;
		MAJ_G(pDoc->m_fDx,pDoc->m_fDy);
	}
	else
	if (pDoc->m_iType&4==0)
	{
		//Poutre XY
		pDoc->m_fDx=x;
		pDoc->m_fDy=y;
	}
	else
	{
		//Poutre XZ
	}
	CView::OnLButtonDown(nFlags, point);
}
//________________________________________
void CBkView::OnUpdateFileSave(CCmdUI* pCmdUI) 
{
	//Invalide si le document est une image	
	//CBkDoc* pDoc=GetDocument();
	//if ((pDoc->m_iType&1)!=0) pCmdUI->Enable(FALSE);
}
//________________________________________
void CBkView::OnUpdateFileSaveAs(CCmdUI* pCmdUI) 
{
	//Invalide si le document est une image	
	//CBkDoc* pDoc=GetDocument();
	//if ((pDoc->m_iType&1)!=0) pCmdUI->Enable(FALSE);
}
//________________________________________
void CBkView::OnUpdateFileOpen(CCmdUI* pCmdUI) 
{
	//On limite le nombre de fentres  m_iNbMax
	if (m_pApp->m_iNb>m_pApp->m_iNbMax-1)  pCmdUI->Enable(FALSE);
}
//________________________________________
short CBkView::SaveSKL(CString s)
{
	unsigned char c;
	short l,h,i,j,rcode;
	long w;
	CBkDoc* pDoc=GetDocument();
	CFile f;
	char buf[512];
	if(!f.Open(s,CFile::modeCreate|CFile::modeWrite))
		rcode=-1;
	else
	{
		CArchive ar(&f,CArchive::store,512,buf);
		//Ecriture____________________________
		ar << pDoc->m_iType;
		ar << pDoc->m_iL;
		ar << pDoc->m_iH;

		pDoc->DimensionnerFenetre(pDoc->m_iL,pDoc->m_iH);

		ar << pDoc->m_fXmi;
		ar << pDoc->m_fXma;
		ar << pDoc->m_fYmi;
		ar << pDoc->m_fYma;
		ar << pDoc->m_fXori;
		ar << pDoc->m_fYori;
		ar << pDoc->m_fEchx;
		ar << pDoc->m_fEchy;
		ar << pDoc->m_fFactx;
		ar << pDoc->m_fFacty;  

		ar << pDoc->m_radioTypeFrange;
		ar << pDoc->m_iType;
		ar << pDoc->m_fIp;
		ar << pDoc->m_fIpp;
		ar << pDoc->m_fF1;
		ar << pDoc->m_fDf;
		ar << pDoc->m_fa;
		ar << (float)0.0;

		ar << pDoc->m_fl;
		ar << pDoc->m_flv;
		ar << pDoc->m_fLambda;
		ar << pDoc->m_fHauteur;
		ar << pDoc->m_fEchz;
		ar << pDoc->m_fEchxy;
		ar << pDoc->m_fDecFr;
		
		i=pDoc->m_sFrTab.GetSize();
		ar << i;
		for (j=0;j<i;j++)
		{
			ar <<pDoc->m_sFrTab.GetAt(j);
		}
		ar << pDoc->m_fFx;
		ar << pDoc->m_fECH;

		//Annotations
		ar << pDoc->a.OK;
		for (i=0;i<6;i++)
		{
			ar << pDoc->a.x[i];
			ar << pDoc->a.y[i];
			ar << pDoc->a.s[i];
			ar << pDoc->a.a[i];
		}
		//Franges
		for (i=0;i<50;i++)
		{
			ar << pDoc->f.x[i];
			ar << pDoc->f.y[i];
			ar << pDoc->f.d[i];
		}

		//Nouvelles version du fichier .skl
		//Origine franges dans image
		ar << pDoc->m_ixOriFr;
		ar << pDoc->m_iyOriFr;
		//Nom du fichier image associ
		ar << (short) pDoc->m_sNomFichierImage.GetLength();
		if (pDoc->m_sNomFichierImage.GetLength()!=0)
		{
			for (i=0;i<pDoc->m_sNomFichierImage.GetLength();i++)
			{
				ar << pDoc->m_sNomFichierImage.GetAt(i);
			}	
			//Image associe
			l=pDoc->m_pDocImage->image->endx;
			h=pDoc->m_pDocImage->image->endy;
			ar << l;
			ar << h;
			for (i=0;i<l;i++)
			{
				for (j=0;j<h;j++)
				{
					w=getpixelcolor(pDoc->m_pDocImage->image,i,j);
					c=w&255;
					ar << c;
				}
			}
		}

		//____________________________________
		ar.Close();
		rcode=0;
		f.Close();
	}
	return rcode;
}
//________________________________________
void CBkView::OnFileSave() 
{
	CString s,s1;
	short 
		rcode=0,
		i;
	class CBkDoc* pDoc=GetDocument();

	if ((pDoc->m_iType&1)!=0)
	{
		AfxMessageBox("Cette fentre ne sera pas sauvegarde !\nSlectionner une visualisation de la poutre.");
	}
	else
	{
		s=pDoc->m_sNomFic;
		if (s.Find(".spe")!=-1  || s.Find(".skl")!=-1)
		{
			rcode=SaveSKL(s);
		}
		else
		if (s.Find(".tif")!=-1)
		{
			rcode=savetif(s,pDoc->image,0);
		}	
		else
		if (s.Find(".jpg")!=-1)
		{
			rcode=savejpg(s,pDoc->image,75);
		}	
		else
		{
			i=s.Find(".");
			if (i==-1)
			{
				//Ajout extension .spe
				s=s+".skl";
				rcode=SaveSKL(s);
			}
			else
				rcode=1;
		}
		s1.Format("(%d) %s",pDoc->m_iNo,s);
		pDoc->SetTitle(s1);	
		if (rcode!=0) AfxMessageBox("Erreur de sauvegarde !");
		pDoc->UpdateAllViews(NULL);
	}
}
//________________________________________
void CBkView::OnFileSaveAs() 
{
	CString s;
	class CBkDoc* pDoc=GetDocument();
	if ((pDoc->m_iType&1)!=0)
	{
		AfxMessageBox("Cette fentre ne sera pas sauvegarde !\nSlectionner une visualisation de la poutre.");
	}
	else
	{
		static char BASED_CODE szFilter[] = "Fichiers speckle (*.skl)|*.skl|Tous les fichiers (*.*)|*.*||";
		CFileDialog dlg(FALSE,"","*.skl",0,szFilter,NULL);
		CFile fic;
		BOOL ok;
		unsigned short j=IDYES;     
		CFileException p_Error;
		short i,rcode=0;
		if (dlg.DoModal()==IDOK)
		{                   
			//On regarde si le fichier existe dj
			ok=fic.Open(dlg.GetPathName(),CFile::modeRead,&p_Error);
			if (ok) fic.Close();
			if (ok)
			{
				j=AfxMessageBox("Ce fichier existe dj. Voulez-vous le remplacer ?",MB_YESNO);
			} 
			if (j==IDYES)
			{
				//Affectation nom du fichier
				s=dlg.GetPathName();
				s.MakeLower();
				if (s.Find(".spe")!=-1 || s.Find(".skl")!=-1)
				{
					rcode=SaveSKL(s);
				}
				else
				if (s.Find(".tif")!=-1)
				{
					rcode=savetif(s,pDoc->image,0);
				}
				else
				if (s.Find(".jpg")!=-1)
				{
					rcode=savejpg(s,pDoc->image,75);
				}
				else
				{
					i=s.Find(".");
					if (i==-1)
					{
						//Ajout extension .skl
						s=s+".skl";
						rcode=SaveSKL(s);
					}
					else
						rcode=1;
				}
				if (rcode!=0) AfxMessageBox("Erreur de sauvegarde !");
			}
			pDoc->m_sNomFic=s;
			CString s1;
			s1.Format("(%d) %s",pDoc->m_iNo,s);
			pDoc->SetTitle(s1);	
		}
		pDoc->UpdateAllViews(NULL);
	}
}
