// CalbDlg.cpp : implementation file
#include "stdafx.h"
#include "Bk.h"
#include "CalbDlg.h"
#include "BkDoc.h"
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//________________________________________
// CCalbDlg dialog
CCalbDlg::CCalbDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCalbDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCalbDlg)
	m_fPixX = 0.0f;
	m_fMmX = 0.0f;
	m_OKCalb = FALSE;
	m_s = _T("");
	//}}AFX_DATA_INIT
	//A ajouter:
	Create(IDD_CALIBRATION,pParent);
}
void CCalbDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCalbDlg)
	DDX_Text(pDX, IDC_PIXX, m_fPixX);
	DDX_Text(pDX, IDC_MMX, m_fMmX);
	DDX_Check(pDX, IDC_CHECK1, m_OKCalb);
	DDX_Text(pDX, IDC_STATIC55, m_s);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CCalbDlg, CDialog)
	//{{AFX_MSG_MAP(CCalbDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//________________________________________
// CCalbDlg message handlers
BOOL CCalbDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	m_pApp=((CBkApp*)AfxGetApp());
	m_pDoc=m_pApp->GetDocument();
	if (m_pDoc!=NULL)
	{
		if (1.0/m_pDoc->m_fECH>1)
		{
			m_fPixX=1;
			m_fMmX=1/m_pDoc->m_fECH;
		}
		else
		{
			m_fPixX=1*m_pDoc->m_fECH;
			m_fMmX=1;
		}
		if ((m_pDoc->m_iType&32)==0) m_OKCalb=FALSE; else m_OKCalb=TRUE; 

		m_s.Format("Vous pouvez aussi digitaliser un segment dans l'image:\n%s",m_pDoc->m_sNomFic);
		UpdateData(FALSE);
	}
	return TRUE;
}
//________________________________________
void CCalbDlg::OnOK() 
{
	float x;
	UpdateData(TRUE);
	//En mm
	m_fPixX=fabs(m_fPixX);
	if (m_fPixX==0) m_fPixX=1;
	m_fMmX=fabs(m_fMmX);
	if (m_fMmX==0) m_fMmX=1;

	x=m_fPixX/m_fMmX;
	m_pDoc->m_fECH=x;
	//Facteur suivant x
	x=m_pDoc->m_iL/x;
	m_pDoc->m_fFx=1e-10;
	do
	{
		m_pDoc->m_fFx=m_pDoc->m_fFx*10;
	}
	while (fabs(x*m_pDoc->m_fFx)<1);	
	if (x*m_pDoc->m_fFx<2) m_pDoc->m_fFx=m_pDoc->m_fFx*10;

	if (m_OKCalb)
	{
		if ((m_pDoc->m_iType&32)==0) m_pDoc->m_iType=m_pDoc->m_iType+32;
	}
	else
	{
		if ((m_pDoc->m_iType&32)==32) m_pDoc->m_iType=m_pDoc->m_iType-32;
	}

	m_pDoc->UpdateAllViews(NULL);

	//Mmorisation position pour affichage dans toutes les fentres associes
	CBkDoc *pDoc1;
	short j;
	CString s,s1;
	for (j=0;j<20;j++)//20 fentres maxi
	{
		pDoc1=m_pApp->GetDocument(j);
		if (pDoc1!=NULL) 
		{
			s=m_pDoc->m_sNomFichierImage;
			s.MakeUpper();
			s1=pDoc1->m_sNomFichierImage;
			s1.MakeUpper();
			if (s.Find(s1)!=-1 && s1.GetLength()!=0)
			{
				pDoc1->m_fECH=m_pDoc->m_fECH;
				pDoc1->m_fFx=m_pDoc->m_fFx;

				if (m_OKCalb)
				{
					if ((pDoc1->m_iType&32)==0) pDoc1->m_iType=pDoc1->m_iType+32;
				}
				else
				{
					if ((pDoc1->m_iType&32)==32) pDoc1->m_iType=pDoc1->m_iType-32;
				}

			}
		}
	}



	m_pApp->m_pCalbDlg=NULL;

	CDialog::OnOK();
}
//________________________________________
void CCalbDlg::PostNcDestroy() 
{
	delete this;
	CDialog::PostNcDestroy();
}
//________________________________________
void CCalbDlg::OnCancel() 
{
	m_pApp->m_pCalbDlg=NULL;
	CDialog::OnCancel();
}
//________________________________________
void CCalbDlg::Fermer(void)
{
	OnCancel();
}
//________________________________________
void CCalbDlg::Affecte(short x1,short y1,short x2,short y2)
{
	float l;
	UpdateData(FALSE);

	m_pApp=((CBkApp*)AfxGetApp());
	CBkDoc *pDoc=m_pApp->GetDocument();
	if (pDoc!=NULL && m_pDoc!=NULL )
	{
		if (m_pDoc==pDoc)
		{
			m_s.Format("Dans l'image:\n%s",pDoc->m_sNomFic);
			l=pow(pow(x1-x2,2)+pow(y1-y2,2),0.5);
			m_fPixX=floor(l);
			m_OKCalb=TRUE;
			m_fMmX=50;
		}
		else
		{
			m_s.Format("ATTENTION !\nRevenir dans l'image: %s",pDoc->m_sNomFic);
		}
		UpdateData(FALSE);
	}
}
