// Dessin.cpp : implementation file
//
#include "stdafx.h"
#include "bk.h"
#include "Dessin.h"
#include "BkDoc.h"
#include "Graphe.h"
#include "GeoAna.h"
#include <math.h>
#include <sys/timeb.h>
#include <locale.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//__________________________________________________
CDessin::CDessin(class CDC* pDC,class CBkDoc* pDoc,float f_ech)
{                       
	m_pApp=(CBkApp*)AfxGetApp();
	m_ech=f_ech;
	m_pDC=pDC;
	m_pDoc=pDoc;
	m_pGr=pDoc->m_pGr;

	m_fHautTexte=4.5;//Hauteur rfrence du texte en mm
	echx=1;
	echy=1;
	xori=0;
	yori=0;
	factx=1;
	facty=1;
	xmi=m_pDoc->m_fXmi;
	ymi=m_pDoc->m_fYmi;
	xma=m_pDoc->m_fXma;
	yma=m_pDoc->m_fYma;  
	//Pas de zoom par dfaut
	InitZoom();
}
//__________________________________________________
CDessin::~CDessin()
{
	//Mise  jour des paramtres de trac
	if (m_pDoc->m_iNb>0)
	{
		m_pDoc->m_fXmi=xmi;	
		m_pDoc->m_fYmi=ymi;	
		m_pDoc->m_fXma=xma;	
		m_pDoc->m_fYma=yma;	
		//Mise  jour des chelles pour affichage coordonnes  l'aide de la souris
		m_pDoc->m_fEchx=echx;	
		m_pDoc->m_fEchy=echy;	
		//Mise  jour du dcalage d'origine pour affichage coordonnes  l'aide de la souris
		m_pDoc->m_fXori=xori;	
		m_pDoc->m_fYori=yori;	
		//Mise  jour du fact. puissance de 10 pour affichage coordonnes  l'aide de la souris
		m_pDoc->m_fFactx=factx;	
		m_pDoc->m_fFacty=facty;	 
	}
}
//__________________________________________________
float CDessin::GFX(float x)
{
	float r;
	r=x/factx;
	r=(r-xori)*echx;
	return r;
}
//__________________________________________________
float CDessin::GFY(float y)
{
	float r;
	r=y/facty;
	r=(r-yori)*echy;
	return r;
}
//__________________________________________________
void CDessin::MoveTo(float x,float y)
{
	m_pDC->MoveTo((int)(x*m_ech),(int)(y*m_ech));
}
//__________________________________________________
void CDessin::LineTo(float x,float y)
{
	m_pDC->LineTo((int)(x*m_ech),(int)(y*m_ech));
}
//__________________________________________________
void CDessin::Line(float xd,float yd,float xa,float ya)
{
	m_pDC->MoveTo((int)(xd*m_ech),(int)(yd*m_ech));
	m_pDC->LineTo((int)(xa*m_ech),(int)(ya*m_ech));
}
//__________________________________________________
void CDessin::Arc(float xg,float yb,float xd,float yh,float x1, float y1,float x2,float y2)
{
	m_pDC->Arc((int)(xg*m_ech),(int)(yb*m_ech),(int)(xd*m_ech),(int)(yh*m_ech),(int)(x1*m_ech),(int)(y1*m_ech),(int)(x2*m_ech),(int)(y2*m_ech));
}
//__________________________________________________
void CDessin::Arc(float xc,float yc,float ray,float xd,float yd,float xa,float ya)
{
  short
  	x1,x2,x3,x4,y1,y2,y3,y4;
  x1=(int)((xc-ray)*m_ech);	
  y1=(int)((yc+ray)*m_ech);	
  x2=(int)((xc+ray)*m_ech);	
  y2=(int)((yc-ray)*m_ech);	
  x3=(int)(xd*m_ech);	
  y3=(int)(yd*m_ech);	
  x4=(int)(xa*m_ech);	
  y4=(int)(ya*m_ech);	
	m_pDC->Arc(x1,y1,x2,y2,x3,y3,x4,y4);
}
//__________________________________________________
void CDessin::Circle(float xc,float yc,float ray)
{
  short
  	x1,x2,x3,x4,y1,y2,y3,y4;
  x1=(int)((xc-ray)*m_ech);	
  y1=(int)((yc+ray)*m_ech);	
  x2=(int)((xc+ray)*m_ech);	
  y2=(int)((yc-ray)*m_ech);	
  x3=(int)((xc-ray)*m_ech);	
  y3=(int)((yc)*m_ech);	
  x4=(int)((xc-ray)*m_ech);	
  y4=(int)((yc)*m_ech);	
	m_pDC->Arc(x1,y1,x2,y2,x3,y3,x4,y4);
}
//__________________________________________________
void CDessin::TextOut(float x,float y,CString s)
{
	m_pDC->TextOut((int)(x*m_ech),(int)(y*m_ech),s);     
}
//__________________________________________________
void CDessin::Rectangle(float xg,float yb,float xd,float yh)
{
	m_pDC->Rectangle((int)(xg*m_ech),(int)(yh*m_ech),(int)(xd*m_ech),(int)(yb*m_ech));
}   
//__________________________________________________
void CDessin::Fleche(float xp,float yp,float a,float l)
{
  const 
  	float PI=(float)(4*atan(1)),
  	ang=(float)(15.0*PI/180);
  a=a+PI;
	m_pDC->MoveTo((int)((xp+l*cos(a+ang))*m_ech),(int)((yp+l*sin(a+ang))*m_ech));
	m_pDC->LineTo((int)(xp*m_ech),(int)(yp*m_ech));
	m_pDC->LineTo((int)((xp+l*cos(a-ang))*m_ech),(int)((yp+l*sin(a-ang))*m_ech));
}
//__________________________________________________
//Nouveau 10/01/03: Fonctions de visibilit du graphe
//									
//NoGraphe [0, 7]
short CDessin::Graphe(char NoGraphe,CString Titre)
{    
	CPen 
  	plumeC,       
  	plumeD,
  	plumeX,
  	plumeY,
  	plumeM,
  	plumeR,
  	plumeI,
  	plumeJ,
  	plumeS,
  	*m_pOldPen;
	CFont 
		fntC,  
		fntD,
		*m_pOldFont;
	COLORREF clrOld;	
	const float M_PI=(float)(4*atan(1));
  short
  	col1,col2,
		i,j,k,
		nb[6]={0,0,0,0,0,0}; 
  float
  	r,
  	x,y,xd,yd,xa,ya,
		xmin=1e10,ymin=1e10,xmax=-1e10,ymax=-1e10,
		larg,haut,  //Dimensions de la fenetre
		pasx,pasy;	
	long
		cc[6]={RGB(255,0,0),RGB(0,128,0),RGB(0,0,128),RGB(221,86,13),RGB(255,0,255),RGB(0,0,0)};	
	CString	s;	             
	BOOL ok;		
	for(i=0;i<m_pDoc->m_iNb;i++)
	{                    
		for (j=0;j<4;j++)
		{
			//Absisses
			//if (iD_Axes[0][j]!=-1 && iD_Axes[1][j]!=-1) 
			col1=m_pGr->RColXGr(NoGraphe,j);
			col2=m_pGr->RColYGr(NoGraphe,j);
			if (col1!=-1 && col2!=-1) 
			{
				if ((m_pGr->RVisG(NoGraphe,j,i)&INVIS)==0)
				//Ce couple abs/ord est  tracer
				if (m_pDoc->m_fT[i][col1]>m_fZoomXmi && m_pDoc->m_fT[i][col1]<m_fZoomXma && m_pDoc->m_fT[i][col2]>m_fZoomYmi && m_pDoc->m_fT[i][col2]<m_fZoomYma) 
				{
					if (m_pDoc->m_fT[i][col1]<xmin) xmin=m_pDoc->m_fT[i][col1];
					if (m_pDoc->m_fT[i][col1]>xmax) xmax=m_pDoc->m_fT[i][col1];
					if (m_pDoc->m_fT[i][col2]<ymin) ymin=m_pDoc->m_fT[i][col2];
					if (m_pDoc->m_fT[i][col2]>ymax) ymax=m_pDoc->m_fT[i][col2];
					nb[j]++;
				}
			}
		}
	}
	ok=FALSE;
	for (k=0;k<4;k++)
	{
		col1=m_pGr->RColXGr(NoGraphe,k);
		col2=m_pGr->RColYGr(NoGraphe,k);
		if (col1!=-1 && col2!=-1 && nb[k]>=2) ok=TRUE;
	}
	if (!ok) return 1;
	//Calcul des chelles, prvoir ventuellement une marge...
	larg=xma-xmi;
	haut=yma-ymi;
  //Si les valeurs sont constantes
	if (fabs(ymax-ymin)<1e-8)
	{
		ymax=(float)(ymax+0.01);
		ymin=(float)(ymin-0.01);
	}
	if (fabs(xmax-xmin)<1e-8)
	{
		xmax=(float)(xmax+0.01);
		xmin=(float)(xmin-0.01);
	}                                
	echx=(larg-70)/(xmax-xmin);                    
	echy=(haut-70)/(ymax-ymin);
	
	if ((m_pGr->RVisG(0,0,0)&ORTHO_NORME)==ORTHO_NORME)
	{
		//Graphe orthonorm
		if (echx<echy) echy=echx; else echx=echy;
	}
	//Calcul pasx
	pasx=1e-10;
	do
	{
		pasx=pasx*10;
	}                              
	while	(echx*pasx<=10);
	//Calcul pasy
	pasy=1e-10;
	do
	{
		pasy=pasy*10;
	}           
	while	(echy*pasy<=10);		
	//Rajustement en fonction du nombre de divisions de l'axe
	i=(int)((xmax-xmin)/pasx);
	if (i<=2) pasx=pasx/4;
	else
	if (i<=5) pasx=pasx/2;
	if (i>12) pasx=pasx*2;

	j=(int)((ymax-ymin)/pasy);
	if (j<=2) pasy=pasy/4;
	else
	if (j<=5) pasy=pasy/2;
	//Recherche facteurs axes x et y
	if (fabs(xmin)>fabs(xmax))
		x=xmin;
	else
		x=xmax;
	if (x!=0)
	{
		factx=1e-10;
		do
		{
			factx=factx*10;
		}
		while (fabs(x*factx)<1);	
	}	                           
	else
		factx=1;

	if (fabs(ymin)>fabs(ymax))
		y=ymin;
	else
		y=ymax;

	if (y!=0)
	{
		facty=1e-10;
		do
		{
			facty=facty*10;
		}
		while (fabs(y*facty)<1);	
	}	                           
	else
		facty=1;
	//Calcul xori et yori
	xori=0;yori=0;
	if ((xmin<=0) && (xmax>=0))
		xori=0;
	else
	{
		//xori=xmin;	
		if (xmin>0)
		{
			//On encadre dans le sens positif
			xori=0;
			do
			{
				xori=xori+pasx;
			}
			while (xori<xmin);
			xori=xori-pasx;
		}
		else
		{
			//On encadre dans le sens ngatif
			xori=0;
			do
			{
				xori=xori-pasx;
			}
			while (xori>xmin);
			xori=xori+pasx;
		}
	}	
	if ((ymin<=0) && (ymax>=0))
		yori=0;
	else
	{
		if (ymin>0)
		{
			//On encadre dans le sens positif
			yori=0;
			do
			{
				yori=yori+pasy;
			}
			while (yori<ymin);
			yori=yori-pasy;
		}
		else
		{
			//On encadre dans le sens ngatif
			yori=0;
			do
			{
				yori=yori-pasy;
			}
			while (yori>ymin);
			yori=yori+pasy;
		}

  }
	//Dplacement de l'origine de la fenetre graphique    
	if (xori!=0)
		xmi=-40;		
	else
		xmi=xmin*echx-40;		
	xma=xmi+larg;		
	if (yori!=0)
		ymi=-30;		
	else
		ymi=ymin*echy-30;		
	yma=ymi+haut;
	//Rajout le 20/12/02 pour viter graphe en dehors zone de trac...
	echx=echx*0.95;
	echy=echy*0.95;
  //Dcalage axes
  m_pDC->SetWindowOrg((int)(m_ech*xmi),(int)(m_ech*yma));

	fntC.CreateFont((int)(m_ech*m_fHautTexte*0.8),0,0,0,FW_MEDIUM,FALSE,FALSE,FALSE,ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH,"Arial");
	m_pOldFont=m_pDC->SelectObject(&fntC);	  
	m_pDC->SetTextAlign(TA_LEFT);							
	clrOld=m_pDC->SetTextColor(RGB(0,0,255));
  plumeC.CreatePen(PS_SOLID,(int)(0.20*m_ech),RGB(0,0,0));
	m_pOldPen=m_pDC->SelectObject(&plumeC);        
  //Rectangle(xmi,ymi,xma,yma);
  Cadre(xmi,ymi,xma,yma);
	//Dtermination zone de trac
	xa=pasx;
	while(xa*echx<=(xma-5))
	{
		xa=xa+pasx;
	}
	xa=xa-pasx;
	xa=xa*echx;
	
	xd=-pasx;
	while(xd*echx>=(xmi+5))
	{
		xd=xd-pasx;
	}
	xd=xd+pasx;
	xd=xd*echx;
  ya=pasy;
  while (ya*echy<=(yma-5))
  {                        
  	ya=ya+pasy;
  }     
  ya=ya-pasy;                  
  ya=ya*echy;
  yd=-pasy;
  while (yd*echy>=(ymi+5))
  {                        
  	yd=yd-pasy;
  } 
  yd=yd+pasy;
  yd=yd*echy;
  //Cadre autour de la zone 
  Cadre(xd,yd-0.25,xa+0.25,ya);
	//Rectangle(xd,yd,xa,ya);

  s.Format("(%d) B.K. - Lyce J. Mermoz - 68300 ST.-LOUIS",m_pDoc->m_iNo);
	TextOut((float)(xmi+0.5),(float)(ymi+4.5),s);
	//Date et heure
	CTime t;
	setlocale(LC_TIME,"French");
	t=CTime::GetCurrentTime();   
	s=t.Format("%A, %d %B %Y - %H:%M:%S");
	m_pDC->SetTextAlign(TA_RIGHT);							
	TextOut((float)(xma-1.0),(float)(ymi+4.5),s);
	//Trac des axes  
	Line(xd,0,xa,0);
	Line(0,yd,0,ya);
  plumeD.CreatePen(PS_SOLID,(int)(0*m_ech),RGB(127,127,127));
	m_pDC->SelectObject(&plumeD);        
	fntD.CreateFont((int)(m_ech*m_fHautTexte),0,0,0,FW_MEDIUM,FALSE,FALSE,FALSE,ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH,"Arial");
	m_pDC->SelectObject(&fntD);	  
	m_pDC->SetTextAlign(TA_CENTER);							
	m_pDC->SetTextColor(RGB(0,0,0));
  //Division axe x
  x=pasx;
  while (x*echx<=(xma-5))
  {           
  	r=x*echx;
  	s.Format("%1.2f",(x+xori)*factx);
  	TextOut(r,-2.5,s);  
  	Line(r,yd,r,-7.00);
  	Line(r,0.0,r,ya);
    x=x+pasx;
  }                   
  x=-pasx;
  while (x*echx>=(xmi+5))
  {           
  	r=x*echx;
  	s.Format("%1.2f",(x+xori)*factx);
  	TextOut(r,-2.5,s);  
  	Line(r,yd,r,-7.00);
  	Line(r,0.0,r,ya);
    x=x-pasx;
  }                      
	//Division axe y
	m_pDC->SetTextAlign(TA_RIGHT);							
	y=0;
	while(y*echy<=(yma-5))
	{          
  	r=y*echy;
  	s.Format("%1.2f",(y+yori)*facty);
  	TextOut(-2.00,(float)(r+2.0),s);  
  	if (xd<-15) Line(xd,r,-10,r);
  	Line(0.0,r,xa,r);
		y=y+pasy;
	}		  
	y=-pasy;
	while(y*echy>=(ymi+5))
	{          
  	r=y*echy;
  	s.Format("%1.2f",(y+yori)*facty);
  	TextOut(-2.00,(float)(r+2.0),s);  
  	if (xd<-15) Line(xd,r,-10,r);
  	Line(0.0,r,xa,r);
		y=y-pasy;
	}		                  
	//Ecriture des chelles
	//Toujours fonteD
	m_pDC->SetTextAlign(TA_BASELINE);							
	s.Format("Echx:%7.2e / Echy:%7.2e",echx,echy);
	TextOut((float)(xd+1.50),(float)(yma-5.00),s);  
	//Ecriture facteurs axes x et noms axes abscisses
	//Toujours fonteD
	m_pDC->SetTextAlign(TA_RIGHT | TA_BOTTOM);							
	r=1.0;          
	for (k=0;k<4;k++)
	{
		col1=m_pGr->RColXGr(NoGraphe,k);
		if (col1!=-1)
		{
			m_pDC->SetTextColor(cc[k]);
			s.Format("(%d) %s*%5.0e",k,m_pGr->ABS[NoGraphe][k],1/factx);
			TextOut(xa-1.0,r,s);
			r=r+5.0;
		}
	}
	//Ecriture du titre
	r=ya-5.0;
	m_pDC->SelectObject(&fntD);	  
	m_pDC->SetTextColor(RGB(0,0,0));
	m_pDC->SetTextAlign(TA_BASELINE);							
	TextOut(3.0,r,Titre);  
	//Ecriture facteurs axes y et noms axes ordonnes
	r=r-5.0;
	m_pDC->SelectObject(&fntD);	  
	m_pDC->SetTextAlign(TA_BASELINE);							
	for (k=0;k<4;k++)
	{
		col2=m_pGr->RColYGr(NoGraphe,k);
		if (col2!=-1)
		{
			m_pDC->SetTextColor(cc[k]);
			s.Format("(%d) %s*%5.0e",k,m_pGr->ORD[NoGraphe][k],1/facty);
			TextOut(3.0,r,s);
			r=r-5.0;
		}
	}
	//Trac graphe                    
  plumeX.CreatePen(PS_SOLID,(int)(0.48*m_ech),cc[0]);
  plumeY.CreatePen(PS_SOLID,(int)(0.48*m_ech),cc[1]);
  plumeM.CreatePen(PS_SOLID,(int)(0.48*m_ech),cc[2]);
  plumeR.CreatePen(PS_SOLID,(int)(0.48*m_ech),cc[3]);
  plumeI.CreatePen(PS_SOLID,(int)(0.48*m_ech),cc[4]);
  plumeJ.CreatePen(PS_SOLID,(int)(0.48*m_ech),cc[5]);
	//Plume de slection de l'lment
  plumeS.CreatePen(PS_SOLID,(int)(0.48*m_ech),RGB(128,128,128));
	for (k=0;k<4;k++)
	{
		col1=m_pGr->RColXGr(NoGraphe,k);
		col2=m_pGr->RColYGr(NoGraphe,k);
		if (col1!=-1 && col2!=-1)
		{
			for (i=1;i<m_pDoc->m_iNb;i++)
			{
				xd=m_pDoc->m_fT[i-1][col1];
				yd=m_pDoc->m_fT[i-1][col2];
				xa=m_pDoc->m_fT[i][col1];
				ya=m_pDoc->m_fT[i][col2];
				if ((m_pGr->RVisG(NoGraphe,k,i)&INVIS)==0)
				if (xd>m_fZoomXmi && yd>m_fZoomYmi && xa<m_fZoomXma && ya<m_fZoomYma)
				{
					if ((m_pGr->RVisG(NoGraphe,k,i)&SELEC)==SELEC)
					{
						//Elment slectionn
						m_pDC->SelectObject(&plumeS);        
					}
					else
					if ((m_pGr->RVisG(NoGraphe,k,i)&COUL_PART)==COUL_PART)
					{
						//Couleur particulire, ex: lambda
						/*
						short lambda=(short)(xa);
						if (lambda<400) lambda=999;
						if (lambda>999) lambda=999;
						m_pDC->SelectObject(&(m_pApp->pl[lambda-400]));
						*/
						m_pDC->SelectObject(&plumeJ);//Ici, couleur particulire -> Noir        
					}
					else
					{
						//Slection des plumes couleur standard
						switch (k)
						{
							case 0:
								m_pDC->SelectObject(&plumeX);        
							break;
							case 1:
								m_pDC->SelectObject(&plumeY);        
							break;
							case 2:
								m_pDC->SelectObject(&plumeM);        
							break;
							case 3:
								m_pDC->SelectObject(&plumeR);        
							break;
							case 4:
								m_pDC->SelectObject(&plumeI);        
							break;
							case 5:
								m_pDC->SelectObject(&plumeJ);        
							break;
						}
					}
					xd=(xd-xori)*echx;
					yd=(yd-yori)*echy;
					xa=(xa-xori)*echx;
					ya=(ya-yori)*echy;
					
					if ((m_pGr->RVisG(NoGraphe,k,i)&BARRE)==0)
					{
						//Nuage de points
						if ((xd>xmi+5)&&(xd<xma-5)&&(yd>ymi+5)&&(yd<yma-5)&&(xa>xmi+5)&&(xa<xma-5)&&(ya>ymi+5)&&(ya<yma-5))
							Line(xd,yd,xa,ya);
					}
					else
					{
						//Barres
						if ((xd>xmi+5)&&(xd<xma-5)&&(yd>ymi+5)&&(yd<yma-5)&&(xa>xmi+5)&&(xa<xma-5)&&(ya>ymi+5)&&(ya<yma-5))
						{
							Line(xd-1,0,xd+1,0);LineTo(xd+1,yd);LineTo(xd-1,yd);LineTo(xd-1,0);
							Line(xa-1,0,xa+1,0);LineTo(xa+1,ya);LineTo(xa-1,ya);LineTo(xa-1,0);
						}
					}
				}
			}
		}
	}
	m_pDC->SelectObject(m_pOldPen);        
	plumeX.DeleteObject();        
	plumeY.DeleteObject();        
	plumeM.DeleteObject();        
	plumeR.DeleteObject();        
	plumeI.DeleteObject();        
	plumeJ.DeleteObject();        
	plumeC.DeleteObject();        
	plumeD.DeleteObject();                          
	plumeS.DeleteObject();                          
	m_pDC->SelectObject(m_pOldFont);        
	fntC.DeleteObject();
	fntD.DeleteObject();
	m_pDC->SetTextColor(clrOld);
	return 0;
} 
//__________________________________________________
void CDessin::InitZoom(void)
{                       
	m_fZoomXmi=-1e10;
	m_fZoomXma=1e10;
	m_fZoomYmi=-1e10;
	m_fZoomYma=1e10;
}
//__________________________________________________
void CDessin::Zoom(float xmi,float ymi,float xma,float yma)
{                       
	float r;
	if (xmi>xma)
	{
		r=xmi;
		xmi=xma;
		xma=r;
	}
	if (ymi>yma)
	{
		r=ymi;
		ymi=yma;
		yma=r;
	}
	m_fZoomXmi=xmi;
	m_fZoomXma=xma;
	m_fZoomYmi=ymi;
	m_fZoomYma=yma;
}
//__________________________________________________
void CDessin::MarqueDePointage(unsigned long coul,float x,float y)
{
	CBrush 
		*m_pOldBrush,
		brosseA,
		brosseB;
	COLORREF clrOld;	

	x=x/factx;
	y=y/facty;
	x=(x-xori)*echx;
	y=(y-yori)*echy;

	brosseA.CreateSolidBrush(RGB(255,255,255));
	brosseB.CreateSolidBrush(coul);
	m_pOldBrush=m_pDC->SelectObject(&brosseA);
	Rectangle(x-0.8,y-0.8,x+0.8,y+0.8);
	m_pDC->SelectObject(&brosseB);
	Rectangle(x-0.6,y-0.6,x+0.6,y+0.6);

	m_pDC->SelectObject(m_pOldBrush);
	brosseA.DeleteObject();
	brosseB.DeleteObject();
}
//__________________________________________________
void CDessin::MarqueDePointageVal(unsigned long coul,float x,float y)
{
	CString s;
	CFont 
		fntD,
		*m_pOldFont;  
	COLORREF clrOld;	

	MarqueDePointage(coul,x,y);

	fntD.CreateFont((int)(m_ech*m_fHautTexte*0.85),0,0,0,FW_MEDIUM,FALSE,FALSE,FALSE,ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH,"Arial");
	m_pOldFont=m_pDC->SelectObject(&fntD);	  
	m_pDC->SetTextAlign(TA_CENTER|TA_BOTTOM);							
	clrOld=m_pDC->SetTextColor(coul);
 	s.Format("%1.3f, %1.3f",x,y);

	x=x/factx;
	y=y/facty;
	x=(x-xori)*echx;
	y=(y-yori)*echy;
 	TextOut(x,y+1.5,s);

	m_pDC->SelectObject(m_pOldFont);
	fntD.DeleteObject();                   
	m_pDC->SetTextColor(clrOld);
}
//__________________________________________________
//__________________________________________________
void CDessin::Cadre(float f_xg,float f_yb,float f_xd,float f_yh)
{
	Line(f_xg,f_yb,f_xd,f_yb);	
	Line(f_xd,f_yb,f_xd,f_yh);	
	Line(f_xd,f_yh,f_xg,f_yh);	
	Line(f_xg,f_yh,f_xg,f_yb);	
}   
//__________________________________________________
void CDessin::TraceReg(short graphe)
{
	CFont 
		fntD,
		*m_pOldFont;  
	COLORREF clrOld;	
	float
		x,y,
		xa,ya,xd,yd;
	float
		a,b,a1,b1,
		PI=3.14159;
	unsigned char v;
	short ordre,n,col1,col2,i,courbe;
	CString s;	
	CPen
  	plumeN,
  	*m_pOldPen;
 	class CGeoAna geo;	
 
	fntD.CreateFont((int)(m_ech*m_fHautTexte),0,0,0,FW_MEDIUM,FALSE,FALSE,FALSE,ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH,"Arial");
	m_pOldFont=m_pDC->SelectObject(&fntD);	  
	m_pDC->SetTextAlign(TA_LEFT|TA_BOTTOM);							
	clrOld=m_pDC->SetTextColor(RGB(0,0,255));
  plumeN.CreatePen(PS_SOLID,(int)(0.40*m_ech),RGB(0,0,0));
	m_pOldPen=m_pDC->SelectObject(&plumeN);        
	for (courbe=0;courbe<4;courbe++)
	{
		col1=m_pDoc->m_pGr->RColXGr(graphe,courbe);
		col2=m_pDoc->m_pGr->RColYGr(graphe,courbe);
		if (col1!=-1 && col2!=-1)
		{
			//Trac des rgressions
			if (m_pDoc->m_pGr->m_OKTrace[graphe][courbe])
			{
				ordre=m_pDoc->m_pGr->m_iTypeReg[graphe][courbe]+1;	
				if (ordre==1)
				{			
					//Rgression linaire
					a=m_pDoc->m_pGr->m_fa[graphe][courbe][1];
					b=m_pDoc->m_pGr->m_fa[graphe][courbe][0];
					if (a!=1e10 && b!=1e10)
					{
						b1=(b-yori)*echy;
						a1=a*echy/echx;
						geo.p2d(-xori*echx,b1,atan(a1),xmi+5,0,PI/2,&xd,&yd);
						if (yd>yma-5)	
							geo.p2d(-xori*echx,b1,atan(a1),0,yma-5,0,&xd,&yd);
						else
						if (yd<ymi+5)	
							geo.p2d(-xori*echx,b1,atan(a1),0,ymi+5,0,&xd,&yd);
  
						geo.p2d(-xori*echx,b1,atan(a1),xma-5,0,PI/2,&xa,&ya);
						if (ya>yma-5) 	
							geo.p2d(-xori*echx,b1,atan(a1),0,yma-5,0,&xa,&ya);
						else
						if (ya<ymi+5) 
							geo.p2d(-xori*echx,b1,atan(a1),0,ymi+5,0,&xa,&ya);

  					Line((float)(xd),(float)(yd),(float)(xa),(float)(ya));
					}
				}			
				else
				{
					//Rgression polynomiale
					xd=1e10;yd=1e10;
					for (i=0;i<m_pDoc->m_iNb;i++)
					{
						v=m_pDoc->m_pGr->RVisG(graphe,courbe,i);
						if ((v&SELEC)==SELEC)
						{
							x=m_pDoc->m_fT[i][col1];
							y=m_pDoc->m_fT[i][col2];
							if (x!=1e10 && y!=1e10)
							{
								y=m_pDoc->m_pGr->m_fa[graphe][courbe][7]*pow(x,7)+m_pDoc->m_pGr->m_fa[graphe][courbe][6]*pow(x,6)+m_pDoc->m_pGr->m_fa[graphe][courbe][5]*pow(x,5)+m_pDoc->m_pGr->m_fa[graphe][courbe][4]*pow(x,4)+m_pDoc->m_pGr->m_fa[graphe][courbe][3]*pow(x,3)+m_pDoc->m_pGr->m_fa[graphe][courbe][2]*pow(x,2)+m_pDoc->m_pGr->m_fa[graphe][courbe][1]*x+m_pDoc->m_pGr->m_fa[graphe][courbe][0];
								x=(x-xori)*echx;
								y=(y-yori)*echy;
								if (xd==1e10 || yd==1e10)
								{
									xd=x;yd=y;
									MoveTo((float)xd,(float)yd);
								}
								else
								{
									xd=x;yd=y;
									LineTo((float)xd,(float)yd);
								}
							}
							else
							{
								//xd=1e10;yd=1e10;
							}
						}
					}
				}
			}
		}
		//Ecriture des coefficients
		n=0;
		for (i=0;i<8;i++)
		{
 			if (m_pDoc->m_pGr->m_fa[graphe][courbe][i]!=1e10 && m_pDoc->m_pGr->m_fa[graphe][courbe][i]!=0)
			{
				n++;
			}
		}
		if (n>0 && m_pDoc->m_pGr->m_OKTrace[graphe][courbe])
		{
			//Trac rectangle
			xd=xma-40*(courbe+1);ya=yma-5;
			xa=xd+35;yd=ya-(n+1)*(m_fHautTexte+0.8);
			Rectangle(xd,yd,xa,ya);
			s.Format("Courbe (%d)",courbe);
			x=xd;
			y=ya-m_fHautTexte-0.8;
			TextOut(x+1.5,y+0.2,s);
			Line(xd,y,xa,y);
			y=y-m_fHautTexte-0.5;
			n=0;
			for (i=0;i<8;i++)
			{
 				if (m_pDoc->m_pGr->m_fa[graphe][courbe][i]!=1e10 && m_pDoc->m_pGr->m_fa[graphe][courbe][i]!=0)
				{
					s.Format("a%d",i);
 					TextOut(x+1.5,y+0.2,s);
					Line(xd+8,y+m_fHautTexte+0.5,xd+8,y);
					s.Format("%12.3e",m_pDoc->m_pGr->m_fa[graphe][courbe][i]);
 					TextOut(x+8.0+1.5,y+0.2,s);
					Line(xd,y,xa,y);
					y=y-m_fHautTexte-0.8;
				}
			}
		}
	}
	m_pDC->SelectObject(m_pOldPen);        
	plumeN.DeleteObject();        
	m_pDC->SelectObject(m_pOldFont);
	fntD.DeleteObject();                   
	m_pDC->SetTextColor(clrOld);
}
//__________________________________________________
void CDessin::EcritAnnotations(void)
{
	CFont 
		fnt,
		*m_pOldFont;  
	COLORREF clrOld;	
	CPen
  	plume,
  	*m_pOldPen;
	float 
		fpx,fpy,
		fLarg=90,
		fHaut=m_fHautTexte+1.0,
		x,y;
	short 
		taille,
		k,l;
	char s[50];
	
	//Dtermination taille de la zone
	short 
		nbL1=0,						//Nb. de lignes intitul principal
		nbL2=0;						//Nb. de lignes lgende

	fnt.CreateFont((short)(m_ech*m_fHautTexte),0,0,0,FW_MEDIUM,FALSE,FALSE,FALSE,ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH,"Arial");
	m_pOldFont=m_pDC->SelectObject(&fnt);	  
	clrOld=m_pDC->SetTextColor(RGB(255,0,255));
  plume.CreatePen(PS_SOLID,0,RGB(255,0,255));
	m_pOldPen=m_pDC->SelectObject(&plume);
	
	k=0;
	if (m_pDoc->a.x[0]!=1e10 && m_pDoc->a.y[0]!=1e10)
	{
		
		for(l=0;l<m_pDoc->a.s[0].GetLength();l++)
		{
			if (m_pDoc->a.s[0].GetAt(l)=='\r')
			{
				//Passage  la ligne dans bote de dialogue
				k=0;s[k]='\0';
				taille=0;
				nbL1++;
			}
			else
			if (taille>36)
			{
				//On dpasse la largeur de la bote de dialogue, on coupe la chane
				k=0;s[k]='\0';
				taille=0;
				nbL1++;
			}
			else
			if (m_pDoc->a.s[0].GetAt(l)!='\n') 
			{
				//On ignore le saut de ligne dans la chane
				s[k]=m_pDoc->a.s[0].GetAt(l);k++;
				s[k]='\0';taille=k;
			}
		}
		if (k!=0) nbL1++;

		for (k=1;k<6;k++)
		{
			if (m_pDoc->a.x[k]!=1e10 && m_pDoc->a.y[k]!=1e10 && m_pDoc->a.s[k].GetLength()!=0) nbL2++;
		}
	}
	//Rectangle autour de l'intitul principal
	if (nbL1!=0)
	{
		fpx=m_pDoc->a.x[0];fpy=m_pDoc->a.y[0];
		fpx=GFX(fpx);fpy=GFY(fpy);
		Rectangle(fpx,fpy-fHaut*nbL1-fHaut*nbL2,fpx+fLarg,fpy);
		if (nbL2!=0) 
		{
			//Sparation horizontale
			MoveTo(fpx,fpy-fHaut*nbL1);LineTo(fpx+fLarg,fpy-fHaut*nbL1);
			//Et verticale
			MoveTo(fpx+10.0,fpy-fHaut*nbL1);LineTo(fpx+10.0,fpy-fHaut*nbL1-fHaut*nbL2);
		}
	}
	m_pDC->SetTextAlign(TA_LEFT|TA_TOP);
	//Ecriture intitul principal
	if (nbL1!=0)
	{
		fpx=GFX(m_pDoc->a.x[0]);fpy=GFY(m_pDoc->a.y[0]);
		k=0;
		y=fpy-0.5;x=fpx+2.0;
		for(l=0;l<m_pDoc->a.s[0].GetLength();l++)
		{
			if (m_pDoc->a.s[0].GetAt(l)=='\r')
			{
				//Passage  la ligne dans bote de dialogue
				s[k]='\0';
				TextOut(x,y,s);
				k=0;s[k]='\0';taille=0;
				y=y-fHaut;
			}
			else
			if (taille>36)
			{
				//La chane dpasse la longueur du cadre
				s[k]=m_pDoc->a.s[0].GetAt(l);k++;
				s[k]='\0';
				TextOut(x,y,s);
				k=0;s[k]='\0';taille=0;
				y=y-fHaut;
			}
			else
			if (m_pDoc->a.s[0].GetAt(l)!='\n')
			{
				s[k]=m_pDoc->a.s[0].GetAt(l);
				k++;
				s[k]='\0';
				taille=k;
			}
		}
		if (k!=0)
		{
			s[k]='\0';
			TextOut(x,y,s);
			y=y-fHaut;
		}
	}
	//Ecriture lgende
	if (nbL1!=0 && nbL2!=0)
	{
		y=fpy-fHaut*nbL1-0.5;x=fpx+5.0;
		for (k=1;k<6;k++)
		{
			if (m_pDoc->a.x[k]!=1e10 && m_pDoc->a.y[k]!=1e10 && m_pDoc->a.s[k].GetLength()!=0)
			{
				m_pDC->SetTextAlign(TA_CENTER|TA_TOP);							
				TextOut(x,y,m_pDoc->a.a[k]);
				m_pDC->SetTextAlign(TA_LEFT|TA_TOP);							
				TextOut(x+10.0,y,m_pDoc->a.s[k]);
				y=y-fHaut;
			}
		}	
	}
	//Ecriture repres
	m_pDC->SetTextAlign(TA_CENTER|TA_BOTTOM);							
	for (k=1;k<6;k++)
	{
		if (m_pDoc->a.x[k]!=1e10 && m_pDoc->a.y[k]!=1e10 && m_pDoc->a.s[k].GetLength()!=0)
		{ 
			//Les coordonnes sont dans le graphique...
			fpx=m_pDoc->a.x[k];fpy=m_pDoc->a.y[k];
			TextOut(GFX(fpx),GFY(fpy)+1.0,m_pDoc->a.a[k]);
			MarqueDePointage(RGB(255,0,255),fpx,fpy);
		}
	}
	m_pDC->SelectObject(m_pOldPen);        
	plume.DeleteObject();        
	m_pDC->SelectObject(m_pOldFont);
	fnt.DeleteObject();                   
	m_pDC->SetTextColor(clrOld);
}
