// Graphe.cpp : implementation file
//
#include "stdafx.h"
#include "bk.h"
#include "Graphe.h"
#include "BkDoc.h"
#include "GeoAna.h"
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//__________________________________________________
CGraphe::CGraphe(class CBkDoc *pDoc,short nbCol)
{
	short graphe,courbe,n;
	m_pGeo=new CGeoAna();
	m_pDoc=pDoc;
	m_iNbMax=m_pDoc->m_iNbMax;
	m_iVisT=new unsigned char[m_iNbMax][8][4];
	//Nb. de colonnes effectives de m_fT
	m_iNbC=nbCol;
	//Dfinition de visibilit pour tous les graphes
	DVisG(VIS|NUAGE|COUL_STD|NON_SELEC|NORME);
	//Jusqu' 8 graphes
	for (graphe=0;graphe<8;graphe++)
	{
		//Jusqu' 4 courbes par graphe
		for (courbe=0;courbe<4;courbe++)
		{
			COL1[graphe][courbe]=-1;COL2[graphe][courbe]=-1;
			ABS[graphe][courbe]="";ORD[graphe][courbe]="";
		}
	}
	m_OKAccro=FALSE;
	m_iC1=-1;m_iC2=-1;m_iNo=-1;
	m_fX=1e10;m_fY=1e10;
	//Rgressions____________________________________
	for (graphe=0;graphe<8;graphe++)
	{
		for (courbe=0;courbe<4;courbe++)
		{
			m_iTypeReg[graphe][courbe]=0;	//Rgression linaire par dfaut
			m_OKTrace[graphe][courbe]=FALSE;
			for (n=0;n<8;n++)
			{
				m_fa[graphe][courbe][n]=1e10;		//Initialisation coefficients rgression
			}
		}
	}
}
//_________________________________________________
CGraphe::~CGraphe(void)
{
	delete[] m_iVisT;
	delete m_pGeo;
}
//_________________________________________________
void CGraphe::Init_Gr(void)
{
	short i,j,graphe,courbe,n;
	for (i=0;i<m_iNbMax;i++)
	{
		for (j=0;j<m_iNbC;j++)
		{
			m_pDoc->m_fT[i][j]=1e10;
		}
	}
	//Dfinition de la visibilit de tous les lments du graphe
	DVisG(VIS|NUAGE|COUL_STD|NORME);
	//Rgressions____________________________________
	for (graphe=0;graphe<8;graphe++)
	{
		for (courbe=0;courbe<4;courbe++)
		{
			m_iTypeReg[graphe][courbe]=0;	//Rgression linaire par dfaut
			m_OKTrace[graphe][courbe]=FALSE;
			for (n=0;n<8;n++)
			{
				m_fa[graphe][courbe][n]=1e10;		//Initialisation coefficients rgression
			}
		}
	}
}
//Dfinition visibilit du graphe___________________
void CGraphe::DVisG(unsigned char Visibilite)
{
	short i,j,k;
	for (i=0;i<m_iNbMax;i++)
	{
		for (j=0;j<4;j++)
		{
			for (k=0;k<8;k++)
			{
				m_iVisT[i][k][j]=Visibilite;
			}
		}
	}
}
//Dfinition visibilit du graphe___________________
void CGraphe::DVisG(short graphe,short courbe,short n,unsigned char Visibilite)
{
	m_iVisT[n][graphe][courbe]=Visibilite;
}
//Retourne visibilit du graphe____________________
unsigned char CGraphe::RVisG(short graphe,short courbe,short n)
{
	return m_iVisT[n][graphe][courbe];
}
///////////////////////////////////////////////////
void CGraphe::DColXGr(char NoGr,char ColX,CString Abs)
{
	//NoGr: n de type du graphe
	//ColX: n de colonne absisse associe
	if (NoGr<0 || NoGr>7) NoGr=0;
	COL1[NoGr][0]=ColX;
	ABS[NoGr][0]=Abs;
}
//_________________________________________________
void CGraphe::DColXGr(char NoGr,char Courbe,char ColX,CString Abs)
{
	//NoGr: n de type du graphe
	//Courbe: n de courbe du graphique (si graphes superposs)
	//ColX: n de colonne absisse associe
	//Jusqu' 8 graphiques diffrents, et jusqu' 4 courbes par graphique
	if (NoGr<0 || NoGr>7) NoGr=0;
	if (Courbe<0 || Courbe>3) Courbe=0;
	COL1[NoGr][Courbe]=ColX;
	ABS[NoGr][Courbe]=Abs;
}
//_________________________________________________
void CGraphe::DColYGr(char NoGr,char ColY,CString Ord)
{
	if (NoGr<0 || NoGr>7) NoGr=0;
	COL2[NoGr][0]=ColY;
	ORD[NoGr][0]=Ord;
}
//_________________________________________________
void CGraphe::DColYGr(char NoGr,char Courbe,char ColY,CString Ord)
{
	if (NoGr<0 || NoGr>7) NoGr=0;
	if (Courbe<0 || Courbe>3) Courbe=0;
	COL2[NoGr][Courbe]=ColY;
	ORD[NoGr][Courbe]=Ord;
}
//_________________________________________________
char CGraphe::RColXGr(char NoGr)
{
	if (NoGr<0 || NoGr>7) NoGr=0;
	return COL1[NoGr][0];
}
//_________________________________________________
char CGraphe::RColYGr(char NoGr)
{
	if (NoGr<0 || NoGr>7) NoGr=0;
	return COL2[NoGr][0];
}
//_________________________________________________
char CGraphe::RColXGr(char NoGr,char Courbe)
{
	if (NoGr<0 || NoGr>7) NoGr=0;
	if (Courbe<0 || Courbe>3) Courbe=0;
	return COL1[NoGr][Courbe];
}
//_________________________________________________
char CGraphe::RColYGr(char NoGr,char Courbe)
{
	if (NoGr<0 || NoGr>7) NoGr=0;
	if (Courbe<0 || Courbe>3) Courbe=0;
	return COL2[NoGr][Courbe];
}
////////////////////////////////////////////////////
//Accrochage souris au graphe_______________________
BOOL CGraphe::AccrocheGraphe(float f_x,float f_y,float ecart)
{
	short i,j1,j2;
	BOOL ok=FALSE;
	float 
		x,y,ec,
		xg,yg;

	i=0;
	do
	{
		j1=0;
		do
		{
			x=m_pDoc->m_fT[i][j1];
			if (x!=1e10)
			{
				xg=x*m_pDoc->m_fFactx;
				ec=fabs(xg-f_x);
				if (ec<ecart)	ok=TRUE;
			}
			if (!ok) j1++;
		}
		while (j1<m_iNbC && ok==FALSE);
		if (ok)
		{
			j2=0;ok=FALSE;
			do
			{
				y=m_pDoc->m_fT[i][j2];
				if (y!=1e10)
				{	
					yg=y*m_pDoc->m_fFacty;
					ec=fabs(yg-f_y);
					if (ec<ecart)	ok=TRUE;
				}
				if (!ok) j2++;
			}
			while (j2<m_iNbC && ok==FALSE);
		}
		if (!ok) i++;
	}
	while (i<m_pDoc->m_iNb && ok==FALSE);
	if (ok)
	{
		m_fX=x;
		m_fY=y;
		m_iNo=i;
		m_iC2=j2;
		m_iC1=j1;
		m_OKAccro=TRUE;
	}
	else
	{
		m_fX=1e10;
		m_fY=1e10;
		m_iNo=-1;
		m_iC2=-1;
		m_iC1=-1;
		m_OKAccro=FALSE;
	}
	return ok;
}
//_________________________________________________
void CGraphe::Dec(void)
{
	if (m_iC1!=-1 && m_iC2!=-1)
	{
		m_iNo--;
		if(m_iNo<0) m_iNo=m_pDoc->m_iNb;
		m_fX=m_pDoc->m_fT[m_iNo][m_iC1];
		m_fY=m_pDoc->m_fT[m_iNo][m_iC2];
	}
}
//_________________________________________________
void CGraphe::Inc(void)
{
	if (m_iC1!=-1 && m_iC2!=-1)
	{
		m_iNo++;
		if(m_iNo>m_pDoc->m_iNb) m_iNo=0;
		m_fX=m_pDoc->m_fT[m_iNo][m_iC1];
		m_fY=m_pDoc->m_fT[m_iNo][m_iC2];
	}
}
//_________________________________________________
BOOL CGraphe::OK(void)
{
	if (m_OKAccro) return TRUE; else return FALSE;
}
//_________________________________________________
short CGraphe::C1(void)
{
	return m_iC1;
}
//_________________________________________________
short CGraphe::C2(void)
{
	return m_iC2;
}
//_________________________________________________
short CGraphe::N(void)
{
	return m_iNo;
}
//_________________________________________________
float CGraphe::X(void)
{
	return m_fX;
}
//_________________________________________________
float CGraphe::Y(void)
{
	return m_fY;
}
///////////////////////////////////////////////////
//Sur tous les graphes
short CGraphe::SelecSegment(BOOL bSelect,float f_x,float f_y,float ecart)
{
	BOOL OK;
	short 
		nb=0,
		col1,col2,
		n,graphe,courbe;
	unsigned char v;

	m_iC1=-1;m_iC2=-1;m_iNo=-1;
	for (courbe=0;courbe<4;courbe++)
	{
		for (graphe=0;graphe<8;graphe++)
		{
			col1=RColXGr(graphe,courbe);
			col2=RColYGr(graphe,courbe);
			if (col1!=-1 && col2!=-1)
			{
				for (n=0;n<m_pDoc->m_iNb;n++)
				{
					OK=SurSegment(f_x,f_y,n,col1,col2,ecart);
					if (OK)
					{
						//Affectation de l'attribut de slection
						v=RVisG(graphe,courbe,n);
						if (bSelect)
						{
							//Slection
							if (!(v&SELEC))
							{
								nb++;
								v=v+SELEC;
								DVisG(graphe,courbe,n,v);
							}
						}
						else
						{
							//Invalidation slection
							if ((v&SELEC)==SELEC)
							{
								nb--;
								v=v-SELEC;
								DVisG(graphe,courbe,n,v);
							}
						}
					}
				}		
			}	
		}
	}
	return nb;
}
//Sur le graphique spcifi________________________
short CGraphe::SelecSegment(BOOL bSelect,short graphe,short courbe,float f_x,float f_y,float ecart)
{
	short 
		col1,col2,
		nb=0,
		i,j,n;
	BOOL OK=FALSE;
	unsigned char v;

	col1=RColXGr(graphe,courbe);
	col2=RColYGr(graphe,courbe);

	n=0;
	if (col1!=-1 && col2!=-1)
	while (n<m_pDoc->m_iNbMax && !OK)
	{
		OK=SurSegment(f_x,f_y,n,col1,col2,ecart);
		n++;
	}
	if (OK)
	{
		//Rfrences du segment slectionn dans le tableau m_fT
		m_iC1=col1;m_iC2=col2;m_iNo=n+1;
		if (m_iNo<0) m_iNo=0;
		if (m_iNo>m_pDoc->m_iNb) m_iNo=m_pDoc->m_iNb;
		//Affectation de l'attribut de slection
		v=RVisG(graphe,courbe,n);
		if (bSelect)
		{
			//Slection
			if (!(v&SELEC))
			{
				nb++;
				v=v+SELEC;
				DVisG(graphe,courbe,n,v);
			}
			else
			{
				//Invalidation slection
				if ((v&SELEC)==SELEC)
				{
					nb--;
					v=v-SELEC;
					DVisG(graphe,courbe,n,v);
				}
			}
		}
	}
	else
	{
		m_iC1=-1;m_iC2=-1;m_iNo=-1;
	}
	return nb;
}
//_________________________________________________
BOOL CGraphe::SurSegment(float xp,float yp,short n,short col1,short col2,float ecart)
{
	BOOL OK=FALSE;
	float 
		PI=4*atan(1),
		ec,
		x,y,xp1,yp1,
		xd,yd,xa,ya,
		ang,b;

	xd=m_pDoc->m_fT[n][col1];
	yd=m_pDoc->m_fT[n][col2];

	if (xd==1e10 || yd==1e10) return FALSE;

	xd=xd*m_pDoc->m_fFactx;
	yd=yd*m_pDoc->m_fFacty;

	if (n+1>=m_pDoc->m_iNb) return FALSE;

	xa=m_pDoc->m_fT[n+1][col1];
	ya=m_pDoc->m_fT[n+1][col2];

	if (xa==1e10 || ya==1e10) return FALSE;

	xa=xa*m_pDoc->m_fFactx;
	ya=ya*m_pDoc->m_fFacty;
	m_pGeo->d2p(xd,yd,xa,ya,&ang,&b);
	if (fabs(xa-xd)>fabs(ya-yd))
	{
		if (xa>xd)
		{
			//Interpoler entre xd et xa
			x=xd;
			while (x<=xa && OK==FALSE)
			{
				//Intersection avec segment
				m_pGeo->p2d(xd,yd,ang,x,0,PI/2,&xp1,&yp1);
				ec=pow(pow(xp1-xp,2)+pow(yp1-yp,2),0.5);
				if (ec<ecart) OK=TRUE;
				x=x+ecart;
			}
		}
		else
		{
			//Interpoler entre xa et xd
			x=xd;
			while (x>=xa && OK==FALSE)
			{
				//Intersection avec segment
				m_pGeo->p2d(xd,yd,ang,x,0,PI/2,&xp1,&yp1);
				ec=pow(pow(xp1-xp,2)+pow(yp1-yp,2),0.5);
				if (ec<ecart) OK=TRUE;
				x=x-ecart;
			}
		}
	}
	else
	{
		if (ya>yd)
		{
			//Interpoler entre yd et ya
			y=yd;
			while (y<=ya && OK==FALSE)
			{
				//Intersection avec segment
				m_pGeo->p2d(xd,yd,ang,0,y,0,&xp1,&yp1);
				ec=pow(pow(xp1-xp,2)+pow(yp1-yp,2),0.5);
				if (ec<ecart) OK=TRUE;
				y=y+ecart;
			}
		}
		else
		{
			//Interpoler entre ya et yd
			y=yd;
			while (y>=ya && OK==FALSE)
			{
				//Intersection avec segment
				m_pGeo->p2d(xd,yd,ang,0,y,0,&xp1,&yp1);
				ec=pow(pow(xp1-xp,2)+pow(yp1-yp,2),0.5);
				if (ec<ecart) OK=TRUE;
				y=y-ecart;
			}
		}
	}
	return OK;
}
//Sur le graphique spcifi________________________
short CGraphe::AccrocheZone(BOOL bSelect,short graphe,short courbe,float xmi,float ymi,float xma,float yma)
{
	short 
		col1,col2,
		i,j,n,nb=0;
	float x,y;
	unsigned char v;

	col1=RColXGr(graphe,courbe);
	col2=RColYGr(graphe,courbe);

	n=0;
	if (col1!=-1 && col2!=-1)
	while (n<m_pDoc->m_iNbMax)
	{
		x=m_pDoc->m_fT[n][col1];
		y=m_pDoc->m_fT[n][col2];
		if (x!=1e10 && y!=1e10)
		{
			x=x*m_pDoc->m_fFactx;
			y=y*m_pDoc->m_fFacty;
			if(x>=xmi && y>=ymi && x<=xma && y<=yma)
			{
				v=RVisG(graphe,courbe,n);
				//Affectation de l'attribut de slection
				if (bSelect)
				{
					if (!(v&SELEC))
					{
						v=v+SELEC;
						DVisG(graphe,courbe,n,v);
						nb++;
					}
				}
				else
				{
					if ((v&SELEC)==SELEC)
					{
						v=v-SELEC;
						DVisG(graphe,courbe,n,v);
						nb--;
					}
				}
			}
		}
		n++;
	}
	return nb;
}
//__________________________________________________
BOOL CGraphe::CalculRegres(double (*m_fT)[2],short nb,short ordre,double *Q)
{
	CString s;
	BOOL ok=TRUE;
	short
		i,j,
		k,l,c;
	double
		det,
		sy=0,sx1y=0,
		sx1=0,sx2=0;

	//Matrices pour rgressions polynomiales
	double A1,Y1,XX[20],XY[20],X1[20],a[11][11],b[11],C[11];
		
	//Initialisation coefficients
	if (nb>1)
	{
		for (k=0;k<8;k++) Q[k]=1e10;
		if (ordre==1)
		{
			//Linaire
			for (k=0;k<nb;k++)
			{
				sx1=sx1+m_fT[k][0];
				sx2=sx2+pow(m_fT[k][0],2);
				sx1y=sx1y+m_fT[k][0]*m_fT[k][1];
				sy=sy+m_fT[k][1];
			}
			det=sx2*nb-sx1*sx1;
			if (fabs(det)<1e-20)
			{
				ok=FALSE;
			}
			else
			{
				Q[1]=-(-sx1y*nb+sy*sx1)/det;
				Q[0]=(sx2*sy-sx1*sx1y)/det;  
			}
		}
		else
		{
			//Rgressions polynomiales d'aprs Yves Gurin
			//Cette mthode fonctionne pour tous les ordres polynomiaux, jusqu' 8...
			//Initialisation
			for (k=0;k<8;k++) Q[k]=0;
			for (j=0;j<20;j++)
			{
				XX[j]=0;XY[j]=0;X1[j]=0;
			}
			
			for (j=0;j<11;j++)
			{
				b[j]=0;C[j]=0;
				for (i=0;i<11;i++)
				{
					a[i][j]=0;
				}
			}
			XX[0]=nb;
			X1[0]=1;
			for (i=1;i<=nb;i++)
			{
				//Valeurs du tableau
				X1[1]=m_fT[i-1][0];
				Y1=m_fT[i-1][1];
				for (j=1;j<=2*ordre;j++)
				{
					X1[j]=X1[1]*X1[j-1];
				}
				for (j=1;j<=2*ordre;j++)
				{
					XX[j]=XX[j]+X1[j];
					XY[j]=XY[j]+Y1*X1[j-1];
				}
			}
			for (l=1;l<=ordre+1;l++)
			{
				b[l]=XY[ordre+2-l];
				for (c=1;c<=ordre+1;c++)
				{
					a[l][c]=XX[2*(ordre+1)-l-c];
				}
			}
			for (k=1;k<=ordre+1;k++)
			{
				for (l=k;l<=ordre+1;l++)
				{
					A1=a[l][k];
					b[l]=b[l]/A1;
					for (c=1;c<=ordre+1;c++)
					{
						a[l][c]=a[l][c]/A1;
					}
				}
				for (l=k+1;l<=ordre+1;l++)
				{
					b[l]=b[k]-b[l];
					for (c=1;c<=ordre+1;c++)
					{
						a[l][c]=a[k][c]-a[l][c];
					}
				}
			}
			i=0;				
			for (k=ordre+1;k>=1;k--)
			{
				C[k]=b[k];
				for (j=k+1;j<=ordre+1;j++)
				{
				C[k]=C[k]-a[k][j]*C[j];
				}
				//Affectation coefficients Q
				Q[i]=C[k];
				i++;
			}
		}
	}
	else
	{
		ok=FALSE;
	}
	return ok;
}
