// MainFrm.cpp : implementation of the CMainFrame class
#include "stdafx.h"
#include "Bk.h"
#include "MainFrm.h"
#include "BkDoc.h"
#include "ProfilDlg.h"
#include "CoteDlg.h"
#include "AnnotDlg.h"
#include "ParaDlg.h"
#include "BkView.h"
#include "InterDlg.h"
#include "FraXYDlg.h"
#include "DefXZDlg.h"
#include "CalbDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//________________________________________
// CMainFrame
IMPLEMENT_DYNAMIC(CMainFrame, CMDIFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CMDIFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_IMAGE_PROFILS, OnImageProfils)
	ON_UPDATE_COMMAND_UI(ID_IMAGE_PROFILS, OnUpdateImageProfils)
	ON_UPDATE_COMMAND_UI(ID_IMAGE_COTATION, OnUpdateImageCotation)
	ON_COMMAND(ID_IMAGE_COTATION, OnImageCotation)
	ON_UPDATE_COMMAND_UI(ID_ANNOTATION, OnUpdateAnnotation)
	ON_COMMAND(ID_ANNOTATION, OnAnnotation)
	ON_UPDATE_COMMAND_UI(ID_PARAMETRES, OnUpdateParametres)
	ON_COMMAND(ID_PARAMETRES, OnParametres)
	ON_UPDATE_COMMAND_UI(ID_DEFORMEE_XZ, OnUpdateDeformeeXz)
	ON_COMMAND(ID_DEFORMEE_XZ, OnDeformeeXz)
	ON_UPDATE_COMMAND_UI(ID_FRANGES_XY, OnUpdateFrangesXy)
	ON_COMMAND(ID_FRANGES_XY, OnFrangesXy)
	ON_COMMAND(ID_GRAPHE, OnGraphe)
	ON_UPDATE_COMMAND_UI(ID_GRAPHE, OnUpdateGraphe)
	ON_UPDATE_COMMAND_UI(ID_CALIBRATION, OnUpdateCalibration)
	ON_COMMAND(ID_CALIBRATION, OnCalibration)
	ON_UPDATE_COMMAND_UI(ID_IMAGE_MIROIR, OnUpdateImageMiroir)
	ON_COMMAND(ID_IMAGE_MIROIR, OnImageMiroir)
	//}}AFX_MSG_MAP
	ON_UPDATE_COMMAND_UI(ID_BK, OnUpdatePage)
	ON_UPDATE_COMMAND_UI(ID_BK1, OnUpdatePage1)
END_MESSAGE_MAP()
static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_BK1,
	ID_BK,
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	//ID_INDICATOR_SCRL,
};
//________________________________________
// CMainFrame construction/destruction
CMainFrame::CMainFrame()
{
	
}
//________________________________________
CMainFrame::~CMainFrame()
{
}
//________________________________________
int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	ShowWindow(SW_SHOWMAXIMIZED);
	
	if (CMDIFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.Create(this) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// TODO: Remove this if you don't want tool tips or a resizeable toolbar
	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);

	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	return 0;
}
BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs
	return CMDIFrameWnd::PreCreateWindow(cs);

}
//________________________________________
// CMainFrame diagnostics
#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CMDIFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CMDIFrameWnd::Dump(dc);
}
#endif //_DEBUG
//________________________________________
// CMainFrame message handlers
void CMainFrame::OnUpdatePage1(CCmdUI *pCmdUI)
{
	m_pApp=((CBkApp*)AfxGetApp());
	m_wndStatusBar.SetPaneInfo(1,ID_BK1,/*SBPS_STRETCH*//*SBPS_POPOUT*/SBPS_NORMAL,250);
	class CBkDoc* pDoc;
	pDoc=m_pApp->GetDocument();
	CString s;
	if (pDoc!=NULL)
	{
		if (pDoc->m_sNomFichierImage.GetLength()==0)
		{
			s="";
		}
		else
		{
			if ((pDoc->m_iType&1)!=1)
				s.Format("Image associe: %s",pDoc->m_sNomFichierImage); 
			else
				s="";
		}
	}
	else
		s="";
	pCmdUI->SetText(s);
}
//________________________________________
void CMainFrame::OnUpdatePage(CCmdUI *pCmdUI)
{
	CString 
		str,s,s1,s2,s3,s4;
	int i,j;
	float x,y,x1,y1;
	long w;
	class CBkDoc* pDoc;
	m_pApp=((CBkApp*)AfxGetApp());
	pDoc=m_pApp->GetDocument();
	m_wndStatusBar.SetPaneInfo(2,ID_BK,/*SBPS_STRETCH*//*SBPS_POPOUT*/SBPS_NORMAL,250);		
	if (pDoc!=NULL)
	//Graphe_________________________________________
	{
		if ((pDoc->m_iType&1)!=1)
		{
			i=pDoc->m_iX-pDoc->m_iDx;
			j=pDoc->m_iY-pDoc->m_iDy;
			if ((pDoc->m_iType&2)==0)
			{
				//Graphe interfrences
				if (pDoc->m_iDx==0)
				{
					pDoc->m_pView->PIX_FEN(i,j,&x,&y);
					pDoc->m_pView->FEN_GR(x,y,&x,&y);

					s.Format("X:%1.3f",x);
					s1.Format("Y:%1.3f",y);
				}
				else
				{
					pDoc->m_pView->PIX_FEN(pDoc->m_iX,pDoc->m_iY,&x,&y);
					pDoc->m_pView->FEN_GR(x,y,&x,&y);
					x1=x;y1=y;
					pDoc->m_pView->PIX_FEN(pDoc->m_iDx,pDoc->m_iDy,&x,&y);
					pDoc->m_pView->FEN_GR(x,y,&x,&y);

					s.Format("dX:%1.3f",x1-x);
					s1.Format("dY:%1.3f",y1-y);
				}
				str.Format("[%d] %s, %s",pDoc->m_iNo,s,s1); 
			}
			else
			{
				//Poutre
				if ((pDoc->m_iType&4)==0)
				{
					//Plan XY, tenir compte de l'chelle de la poutre...
					if (pDoc->m_fDx==0)
						s.Format("[%d] X(mm): %1.1f",pDoc->m_iNo,pDoc->m_fX/pDoc->m_fEchxy);
					else
						s.Format("[%d] dX(mm): %1.1f",pDoc->m_iNo,(pDoc->m_fX-pDoc->m_fDx)/pDoc->m_fEchxy);
					str.Format("%s",s);
				}
				else
				{
					//Plan XZ
					if (pDoc->m_fDx==0)
						s.Format("[%d] X(mm): %1.1f, Z(m): %1.1f",pDoc->m_iNo,pDoc->m_fX/pDoc->m_fEchxy,1000*pDoc->m_fY/pDoc->m_fEchz);
					else
						s.Format("[%d] dX(mm): %1.1f, dZ(m): %1.1f",pDoc->m_iNo,(pDoc->m_fX-pDoc->m_fDx)/pDoc->m_fEchxy,1000*(pDoc->m_fY-pDoc->m_fDy)/pDoc->m_fEchz);
					str.Format("%s",s);
				}
			}
			pCmdUI->SetText(str);
		}
		//Image__________________________________________
		else
		{
			if ((pDoc->m_iType&32)==32)
			{
				//Image calibre
				if (pDoc->m_iDx==0)
				{
					x=1.0*pDoc->m_iX*pDoc->m_fFx/pDoc->m_fECH;
					y=1.0*pDoc->m_iY*pDoc->m_fFx/pDoc->m_fECH;
					s.Format("X:%1.3f",x);
					s1.Format("Y:%1.3f",y);
				}
				else
				{
					x=1.0*(pDoc->m_iX-pDoc->m_iDx)*pDoc->m_fFx/pDoc->m_fECH;
					y=1.0*(pDoc->m_iY-pDoc->m_iDy)*pDoc->m_fFx/pDoc->m_fECH;
					s.Format("dX:%1.3f",x);
					s1.Format("dY:%1.3f",y);
				}
				str.Format("[%d] %s, %s  (mm*%1.0e)",pDoc->m_iNo,s,s1,1.0/pDoc->m_fFx); 
				pCmdUI->SetText(str); 
			}
			else
			{
				//Image en pixel en coordonnes absolues
				if (pDoc->m_iNbB==8)
				{
					if (pDoc->m_iDx==0)
					{
						//Image en pixel en coordonnes absolues en 8 bits
						s.Format("X:%d",pDoc->m_iX);
						s1.Format("Y:%d",pDoc->m_iY);
						s2.Format("W:%d",pDoc->m_iW);
					}
					else
					{
						//Image en pixel en coordonnes relatives en 8 bits
						s.Format("dX:%d",pDoc->m_iX-pDoc->m_iDx);
						s1.Format("dY:%d",pDoc->m_iY-pDoc->m_iDy);
						s2.Format("dW:%d",pDoc->m_iW-pDoc->m_iDw);
					}
					str.Format("[%d] %s, %s, %s",pDoc->m_iNo,s,s1,s2); 
					pCmdUI->SetText(str);
				}
				else
				{
					if (pDoc->m_iDx==0)
					{
						//Image en pixel en coordonnes absolues en 24 bits
						s.Format("X:%d,",pDoc->m_iX);
						s1.Format("Y:%d,",pDoc->m_iY);
						w=pDoc->m_iW;
						s2.Format("R:%d,",w&255); 
						s3.Format("V:%d,",(w/256)&255); 
						s4.Format("B:%d",(w/65536)&255); 
					}
					else
					{
						//Image en pixel en coordonnes relatives en 24 bits
						s.Format("dX:%d",pDoc->m_iX-pDoc->m_iDx);
						s1.Format("dY:%d",pDoc->m_iY-pDoc->m_iDy);
						w=pDoc->m_iW;
						w=(w&255)-(pDoc->m_iDw&255);
						s2.Format("dR:%d,",w); 
						w=pDoc->m_iW; 
						w=((w/256)&255)-((pDoc->m_iDw/256)&255);
						s3.Format("dV:%d,",w); 
						w=pDoc->m_iW; 
						w=((w/65536)&255)-((pDoc->m_iDw/65536)&255);
						s4.Format("dB:%d",w); 
					}
					str.Format("[%d] %s %s %s %s %s",pDoc->m_iNo,s,s1,s2,s3,s4); 
					pCmdUI->SetText(str); 
				}
			}		
		}
	}
	else
		pCmdUI->SetText(""); 

}
//Botes de dialogue non modales...
//_________________________________________________
void CMainFrame::OnUpdateImageProfils(CCmdUI* pCmdUI) 
{
	if (m_pApp->m_pProfilDlg!=NULL)	
		pCmdUI->Enable(FALSE);
	else
	if (m_pApp->GetDocument()==NULL)	
		pCmdUI->Enable(FALSE);
	else
	//Si document pas image
	if ((m_pApp->GetDocument()->m_iType&1)!=1)
		pCmdUI->Enable(FALSE);
}
//_________________________________________________
void CMainFrame::OnImageProfils() 
{
	m_pApp->m_pProfilDlg=new CProfilDlg(this);
}
//_________________________________________________
void CMainFrame::OnUpdateImageCotation(CCmdUI* pCmdUI) 
{
	if (m_pApp->m_pCoteDlg!=NULL)
		pCmdUI->Enable(FALSE);
	else			
	if (m_pApp->GetDocument()==NULL)
		pCmdUI->Enable(FALSE);
	else
	//Si document pas image
	if ((m_pApp->GetDocument()->m_iType&1)!=1)
		pCmdUI->Enable(FALSE);
}
//_________________________________________________
void CMainFrame::OnImageCotation() 
{
	m_pApp->m_pCoteDlg=new CCoteDlg(this);
}
//_________________________________________________
void CMainFrame::OnUpdateAnnotation(CCmdUI* pCmdUI) 
{
	if (m_pApp->m_pAnnotDlg!=NULL)	pCmdUI->Enable(FALSE);
	if (m_pApp->GetDocument()==NULL)	pCmdUI->Enable(FALSE);
}
//_________________________________________________
void CMainFrame::OnAnnotation() 
{
	m_pApp->m_pAnnotDlg=new CAnnotDlg(this);
}
//_________________________________________________
void CMainFrame::OnUpdateParametres(CCmdUI* pCmdUI) 
{
	if (m_pApp->m_pParaDlg!=NULL)	pCmdUI->Enable(FALSE);
	if (m_pApp->GetDocument()==NULL)	pCmdUI->Enable(FALSE);
}
//_________________________________________________
void CMainFrame::OnParametres() 
{
	m_pApp->m_pParaDlg=new CParaDlg(this);
}
//________________________________________
void CMainFrame::OnGraphe() 
{
	//Graphe de la fonction d'interfrence	
	CInterDlg d;
	d.DoModal();
}
//________________________________________
void CMainFrame::OnFrangesXy() 
{
	//Franges dans le plan XY	
	CFraXYDlg d;
	d.DoModal();
}
//________________________________________
void CMainFrame::OnDeformeeXz() 
{
	//Dformes dans le plan XZ	
	CDefXZDlg d;
	d.DoModal();
}

//________________________________________
void CMainFrame::OnUpdateFrangesXy(CCmdUI* pCmdUI) 
{
	if (m_pApp->m_iNb>=m_pApp->m_iNbMax) pCmdUI->Enable(FALSE);
	
}
//________________________________________
void CMainFrame::OnUpdateGraphe(CCmdUI* pCmdUI) 
{
	if (m_pApp->m_iNb>=m_pApp->m_iNbMax) pCmdUI->Enable(FALSE);
	
}
//________________________________________
void CMainFrame::OnUpdateDeformeeXz(CCmdUI* pCmdUI) 
{
	if (m_pApp->m_iNb>=m_pApp->m_iNbMax) pCmdUI->Enable(FALSE);
}
//________________________________________
void CMainFrame::OnUpdateCalibration(CCmdUI* pCmdUI) 
{
	if (m_pApp->m_pCalbDlg!=NULL)	pCmdUI->Enable(FALSE);
	if (m_pApp->GetDocument()==NULL)
		pCmdUI->Enable(FALSE);
	else
		//Invalide si le document n'est pas une image	
		if ((m_pApp->GetDocument()->m_iType&1)!=1) pCmdUI->Enable(FALSE);
}
//________________________________________
void CMainFrame::OnCalibration() 
{
	m_pApp->m_pCalbDlg=new CCalbDlg(this);
}
//________________________________________
void CMainFrame::OnUpdateImageMiroir(CCmdUI* pCmdUI) 
{
	if (m_pApp->GetDocument()==NULL)
		pCmdUI->Enable(FALSE);
	else
		//Invalide si le document n'est pas une image	
		if ((m_pApp->GetDocument()->m_iType&1)!=1) pCmdUI->Enable(FALSE);
}
//________________________________________
void CMainFrame::OnImageMiroir() 
{
	CBkDoc *pDoc;
	pDoc=m_pApp->GetDocument();
	mirrorimage(pDoc->image,pDoc->image);
	pDoc->UpdateAllViews(NULL);
}
