// ProfilDlg.cpp : implementation file
//
#include "stdafx.h"
#include "Bk.h"
#include "ProfilDlg.h"
#include "BkDoc.h"
#include "BkView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
/////////////////////////////////////////////////////////////////////////////
// CProfilDlg dialog
CProfilDlg::CProfilDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CProfilDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CProfilDlg)
	m_s = _T("");
	m_radioRouge = -1;
	m_OKProfilH = FALSE;
	m_OKProfilV = FALSE;
	//}}AFX_DATA_INIT
	//A ajouter:
	Create(IDD_PROFIL,pParent);
}
void CProfilDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CProfilDlg)
	DDX_Text(pDX, IDC_STATIC_TEXTE, m_s);
	DDX_Radio(pDX, IDC_ROUG, m_radioRouge);
	DDX_Check(pDX, IDC_PROFILH, m_OKProfilH);
	DDX_Check(pDX, IDC_PROFILV, m_OKProfilV);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CProfilDlg, CDialog)
	//{{AFX_MSG_MAP(CProfilDlg)
	ON_BN_CLICKED(IDC_PROFILH, OnProfilh)
	ON_BN_CLICKED(IDC_PROFILV, OnProfilv)
	ON_BN_CLICKED(IDC_ROUG, OnRouge)
	ON_BN_CLICKED(IDC_VERT, OnVert)
	ON_BN_CLICKED(IDC_BLEU, OnBleu)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
/////////////////////////////////////////////////////////////////////////////
void CProfilDlg::PostNcDestroy()
{
	delete this;
}
//_________________________________________________
void CProfilDlg::OnCancel() 
{
	CBkDoc *pDoc=m_pApp->GetDocument();
	if (pDoc!=NULL) 
	{
		pDoc->UpdateAllViews(NULL);
	}
	m_pApp->m_pProfilDlg=NULL;
	CDialog::OnCancel();
}
//_________________________________________________
void CProfilDlg::OnOK() 
{
	CBkDoc *pDoc=m_pApp->GetDocument();
	if (pDoc!=NULL)	pDoc->UpdateAllViews(NULL);
	if ((!m_OKProfilH) && (!m_OKProfilV))
	{
		pDoc->p.x1=-1;
		pDoc->p.y1=-1;
		pDoc->p.x2=-1;
		pDoc->p.y2=-1;
	}
	m_pApp->m_pProfilDlg=NULL;
	CDialog::OnOK();
}
//_________________________________________________
BOOL CProfilDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	m_pApp=((CBkApp*)AfxGetApp());
	CBkDoc *pDoc=m_pApp->GetDocument();
	short no=pDoc->m_iNo;
	m_s.Format("Digitalisez une zone dans l'image %d...",no);
	MAJ();
	UpdateData(FALSE);	
	return TRUE;
}
//_________________________________________________
void CProfilDlg::Affecte(short x1,short y1,short x2,short y2)
{
	m_pApp=((CBkApp*)AfxGetApp());
	CBkDoc *pDoc=m_pApp->GetDocument();
	m_s.Format("Digitalisation dans image %d: %d,%d,%d,%d",pDoc->m_iNo,x1,y1,x2,y2);
	UpdateData(FALSE);
}
//_________________________________________________
void CProfilDlg::MAJ(void)
{
	m_pApp=((CBkApp*)AfxGetApp());
	CBkDoc *pDoc=m_pApp->GetDocument();
	if (pDoc!=NULL)
	{
		if (pDoc->p.H) m_OKProfilH=TRUE; else	m_OKProfilH=FALSE;
		if (pDoc->p.V) m_OKProfilV=TRUE; else	m_OKProfilV=FALSE;
		m_radioRouge=pDoc->p.RGB;
	}
	m_s.Format("Digitalisez une zone dans l'image %d...",pDoc->m_iNo);
	UpdateData(FALSE);
}
//_________________________________________________
void CProfilDlg::OnProfilh() 
{
	UpdateData(TRUE);
	m_pApp=((CBkApp*)AfxGetApp());
	CBkDoc *pDoc=m_pApp->GetDocument();
	if (pDoc!=NULL)
	{
		if (m_OKProfilH) pDoc->p.H=TRUE; else pDoc->p.H=FALSE;
	}
}
//_________________________________________________
void CProfilDlg::OnProfilv() 
{
	UpdateData(TRUE);
	m_pApp=((CBkApp*)AfxGetApp());
	CBkDoc *pDoc=m_pApp->GetDocument();
	if (pDoc!=NULL)
	{
		if (m_OKProfilV) pDoc->p.V=TRUE; else pDoc->p.V=FALSE;
	}
}
//_________________________________________________
void CProfilDlg::OnRouge() 
{
	UpdateData(TRUE);
	m_pApp=((CBkApp*)AfxGetApp());
	CBkDoc *pDoc=m_pApp->GetDocument();
	if (pDoc!=NULL)
	{
		pDoc->p.RGB=m_radioRouge;
	}	
}
//_________________________________________________
void CProfilDlg::OnVert() 
{
	UpdateData(TRUE);
	m_pApp=((CBkApp*)AfxGetApp());
	CBkDoc *pDoc=m_pApp->GetDocument();
	if (pDoc!=NULL)
	{
		pDoc->p.RGB=m_radioRouge;
	}	
}
//_________________________________________________
void CProfilDlg::OnBleu() 
{
	UpdateData(TRUE);
	m_pApp=((CBkApp*)AfxGetApp());
	CBkDoc *pDoc=m_pApp->GetDocument();
	if (pDoc!=NULL)
	{
		pDoc->p.RGB=m_radioRouge;
	}	
}
